
/*
Win32 no optimized back end for lcc
*/

#include "c.h"

#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address     ARGS((Symbol, Symbol, int));
static void blkfetch    ARGS((int, int, int, int));
static void blkloop     ARGS((int, int, int, int, int, int[]));
static void blkstore    ARGS((int, int, int, int));
static int  ckstack     ARGS((Node, int));
static void defaddress  ARGS((Symbol));
static void defconst    ARGS((int, Value));
static void defstring   ARGS((int, char *));
static void defsymbol   ARGS((Symbol));
static void doarg       ARGS((Node));
static void emit0       ARGS((Node));
static void emit2       ARGS((Node));
static void export      ARGS((Symbol));
static void clobber     ARGS((Node));
static void function    ARGS((Symbol, Symbol [], Symbol [], int));
static void global      ARGS((Symbol));
static void import      ARGS((Symbol));
static void local       ARGS((Symbol));
static void progbeg     ARGS((int, char **));
static void progend     ARGS((void));
static void segment     ARGS((int));
static void space       ARGS((int));
static void target      ARGS((Node));
static int memop ARGS((Node));
static int hasargs ARGS((Node));
#ifdef ASM_LIB
extern int sametree(Node,Node);
#else
static int sametree (Node, Node);
#endif


/*
generated at Fri May  5 14:16:16 1995
by $Id: lburg.c,v 2.2 1994/12/08 16:10:01 cwf Exp $
*/
static void _kids ARGS((NODEPTR_TYPE, int, NODEPTR_TYPE[]));
static void _label ARGS((NODEPTR_TYPE));
static int _rule ARGS((void*, int));

#define _stmt_NT 1
#define _reg_NT 2
#define _freg_NT 3
#define _con_NT 4
#define _acon_NT 5
#define _baseaddr_NT 6
#define _base_NT 7
#define _con1_NT 8
#define _icon_NT 9
#define _index_NT 10
#define _addr_NT 11
#define _memb_NT 12
#define _memw_NT 13
#define _mem_NT 14
#define _rc5_NT 15
#define _rc_NT 16
#define _mr_NT 17
#define _mrb_NT 18
#define _mrw_NT 19
#define _mrc_NT 20
#define _mrca_NT 21
#define _memf_NT 22
#define _flt_NT 23
#define _addrj_NT 24
#define _addrjmp_NT 25
#define _cmpf_NT 26

static char *_ntname[] = {
	0,
	"stmt",
	"reg",
	"freg",
	"con",
	"acon",
	"baseaddr",
	"base",
	"con1",
	"icon",
	"index",
	"addr",
	"memb",
	"memw",
	"mem",
	"rc5",
	"rc",
	"mr",
	"mrb",
	"mrw",
	"mrc",
	"mrca",
	"memf",
	"flt",
	"addrj",
	"addrjmp",
	"cmpf",
	0
};
struct _state {
	short cost[27];
	struct {
		unsigned char _stmt;
		unsigned char _reg;
		unsigned char _freg;
		unsigned char _con;
		unsigned char _acon;
		unsigned char _baseaddr;
		unsigned char _base;
		unsigned char _con1;
		unsigned char _icon;
		unsigned char _index;
		unsigned char _addr;
		unsigned char _memb;
		unsigned char _memw;
		unsigned char _mem;
		unsigned char _rc5;
		unsigned char _rc;
		unsigned char _mr;
		unsigned char _mrb;
		unsigned char _mrw;
		unsigned char _mrc;
		unsigned char _mrca;
		unsigned char _memf;
		unsigned char _flt;
		unsigned char _addrj;
		unsigned char _addrjmp;
		unsigned char _cmpf;
	} rule;
};
static short _nts_0[] = { 0 };
static short _nts_1[] = { _reg_NT, 0 };
static short _nts_2[] = { _freg_NT, 0 };
static short _nts_3[] = { _reg_NT, _acon_NT, 0 };
static short _nts_4[] = { _reg_NT, _icon_NT, 0 };
static short _nts_5[] = { _base_NT, 0 };
static short _nts_6[] = { _baseaddr_NT, 0 };
static short _nts_7[] = { _index_NT, _baseaddr_NT, 0 };
static short _nts_8[] = { _reg_NT, _baseaddr_NT, 0 };
static short _nts_9[] = { _index_NT, _reg_NT, 0 };
static short _nts_10[] = { _index_NT, 0 };
static short _nts_11[] = { _addr_NT, 0 };
static short _nts_12[] = { _con_NT, 0 };
static short _nts_13[] = { _mem_NT, 0 };
static short _nts_14[] = { _memb_NT, 0 };
static short _nts_15[] = { _memw_NT, 0 };
static short _nts_16[] = { _rc_NT, 0 };
static short _nts_17[] = { _mr_NT, 0 };
static short _nts_18[] = { _mrb_NT, 0 };
static short _nts_19[] = { _mrw_NT, 0 };
static short _nts_20[] = { _reg_NT, _mrc_NT, 0 };
static short _nts_21[] = { _reg_NT, _rc5_NT, 0 };
static short _nts_22[] = { _addr_NT, _mem_NT, _con1_NT, 0 };
static short _nts_23[] = { _addr_NT, _mem_NT, _rc_NT, 0 };
static short _nts_24[] = { _addr_NT, _mem_NT, 0 };
static short _nts_25[] = { _addr_NT, _mem_NT, _rc5_NT, 0 };
static short _nts_26[] = { _con_NT, _mr_NT, 0 };
static short _nts_27[] = { _reg_NT, _mr_NT, 0 };
static short _nts_28[] = { _reg_NT, _reg_NT, 0 };
static short _nts_29[] = { _addr_NT, _rc_NT, 0 };
static short _nts_30[] = { _mrca_NT, 0 };
static short _nts_31[] = { _memf_NT, 0 };
static short _nts_32[] = { _addr_NT, _freg_NT, 0 };
static short _nts_33[] = { _freg_NT, _flt_NT, 0 };
static short _nts_34[] = { _freg_NT, _memf_NT, 0 };
static short _nts_35[] = { _freg_NT, _freg_NT, 0 };
static short _nts_36[] = { _addrjmp_NT, 0 };
static short _nts_37[] = { _mem_NT, _rc_NT, 0 };
static short _nts_38[] = { _cmpf_NT, _freg_NT, 0 };
static short _nts_39[] = { _addrj_NT, 0 };

static short *_nts[] = {
	0,	/* 0 */
	_nts_0,	/* 1 */
	_nts_0,	/* 2 */
	_nts_0,	/* 3 */
	_nts_0,	/* 4 */
	_nts_0,	/* 5 */
	_nts_0,	/* 6 */
	_nts_1,	/* 7 */
	_nts_1,	/* 8 */
	_nts_1,	/* 9 */
	_nts_1,	/* 10 */
	_nts_2,	/* 11 */
	_nts_2,	/* 12 */
	_nts_0,	/* 13 */
	_nts_0,	/* 14 */
	_nts_0,	/* 15 */
	_nts_0,	/* 16 */
	_nts_0,	/* 17 */
	_nts_1,	/* 18 */
	_nts_2,	/* 19 */
	_nts_1,	/* 20 */
	_nts_1,	/* 21 */
	_nts_1,	/* 22 */
	_nts_1,	/* 23 */
	_nts_0,	/* 24 */
	_nts_0,	/* 25 */
	_nts_0,	/* 26 */
	_nts_0,	/* 27 */
	_nts_0,	/* 28 */
	_nts_0,	/* 29 */
	_nts_0,	/* 30 */
	_nts_1,	/* 31 */
	_nts_3,	/* 32 */
	_nts_3,	/* 33 */
	_nts_3,	/* 34 */
	_nts_0,	/* 35 */
	_nts_0,	/* 36 */
	_nts_0,	/* 37 */
	_nts_0,	/* 38 */
	_nts_0,	/* 39 */
	_nts_0,	/* 40 */
	_nts_0,	/* 41 */
	_nts_0,	/* 42 */
	_nts_0,	/* 43 */
	_nts_0,	/* 44 */
	_nts_1,	/* 45 */
	_nts_4,	/* 46 */
	_nts_4,	/* 47 */
	_nts_5,	/* 48 */
	_nts_6,	/* 49 */
	_nts_7,	/* 50 */
	_nts_8,	/* 51 */
	_nts_9,	/* 52 */
	_nts_7,	/* 53 */
	_nts_8,	/* 54 */
	_nts_9,	/* 55 */
	_nts_7,	/* 56 */
	_nts_8,	/* 57 */
	_nts_9,	/* 58 */
	_nts_10,	/* 59 */
	_nts_11,	/* 60 */
	_nts_11,	/* 61 */
	_nts_11,	/* 62 */
	_nts_11,	/* 63 */
	_nts_0,	/* 64 */
	_nts_1,	/* 65 */
	_nts_1,	/* 66 */
	_nts_12,	/* 67 */
	_nts_1,	/* 68 */
	_nts_13,	/* 69 */
	_nts_1,	/* 70 */
	_nts_14,	/* 71 */
	_nts_1,	/* 72 */
	_nts_15,	/* 73 */
	_nts_13,	/* 74 */
	_nts_14,	/* 75 */
	_nts_15,	/* 76 */
	_nts_16,	/* 77 */
	_nts_11,	/* 78 */
	_nts_17,	/* 79 */
	_nts_18,	/* 80 */
	_nts_19,	/* 81 */
	_nts_12,	/* 82 */
	_nts_1,	/* 83 */
	_nts_1,	/* 84 */
	_nts_1,	/* 85 */
	_nts_1,	/* 86 */
	_nts_1,	/* 87 */
	_nts_20,	/* 88 */
	_nts_20,	/* 89 */
	_nts_20,	/* 90 */
	_nts_20,	/* 91 */
	_nts_20,	/* 92 */
	_nts_20,	/* 93 */
	_nts_20,	/* 94 */
	_nts_20,	/* 95 */
	_nts_20,	/* 96 */
	_nts_21,	/* 97 */
	_nts_21,	/* 98 */
	_nts_21,	/* 99 */
	_nts_21,	/* 100 */
	_nts_1,	/* 101 */
	_nts_1,	/* 102 */
	_nts_22,	/* 103 */
	_nts_22,	/* 104 */
	_nts_22,	/* 105 */
	_nts_22,	/* 106 */
	_nts_22,	/* 107 */
	_nts_22,	/* 108 */
	_nts_23,	/* 109 */
	_nts_23,	/* 110 */
	_nts_23,	/* 111 */
	_nts_23,	/* 112 */
	_nts_23,	/* 113 */
	_nts_23,	/* 114 */
	_nts_23,	/* 115 */
	_nts_24,	/* 116 */
	_nts_24,	/* 117 */
	_nts_25,	/* 118 */
	_nts_25,	/* 119 */
	_nts_25,	/* 120 */
	_nts_25,	/* 121 */
	_nts_20,	/* 122 */
	_nts_26,	/* 123 */
	_nts_27,	/* 124 */
	_nts_28,	/* 125 */
	_nts_28,	/* 126 */
	_nts_28,	/* 127 */
	_nts_28,	/* 128 */
	_nts_1,	/* 129 */
	_nts_1,	/* 130 */
	_nts_1,	/* 131 */
	_nts_1,	/* 132 */
	_nts_11,	/* 133 */
	_nts_11,	/* 134 */
	_nts_11,	/* 135 */
	_nts_11,	/* 136 */
	_nts_1,	/* 137 */
	_nts_1,	/* 138 */
	_nts_1,	/* 139 */
	_nts_1,	/* 140 */
	_nts_1,	/* 141 */
	_nts_1,	/* 142 */
	_nts_1,	/* 143 */
	_nts_1,	/* 144 */
	_nts_13,	/* 145 */
	_nts_16,	/* 146 */
	_nts_0,	/* 147 */
	_nts_29,	/* 148 */
	_nts_29,	/* 149 */
	_nts_29,	/* 150 */
	_nts_29,	/* 151 */
	_nts_28,	/* 152 */
	_nts_30,	/* 153 */
	_nts_30,	/* 154 */
	_nts_1,	/* 155 */
	_nts_11,	/* 156 */
	_nts_11,	/* 157 */
	_nts_11,	/* 158 */
	_nts_31,	/* 159 */
	_nts_32,	/* 160 */
	_nts_32,	/* 161 */
	_nts_32,	/* 162 */
	_nts_2,	/* 163 */
	_nts_2,	/* 164 */
	_nts_2,	/* 165 */
	_nts_2,	/* 166 */
	_nts_31,	/* 167 */
	_nts_2,	/* 168 */
	_nts_33,	/* 169 */
	_nts_33,	/* 170 */
	_nts_34,	/* 171 */
	_nts_35,	/* 172 */
	_nts_34,	/* 173 */
	_nts_35,	/* 174 */
	_nts_33,	/* 175 */
	_nts_33,	/* 176 */
	_nts_34,	/* 177 */
	_nts_35,	/* 178 */
	_nts_34,	/* 179 */
	_nts_35,	/* 180 */
	_nts_2,	/* 181 */
	_nts_2,	/* 182 */
	_nts_32,	/* 183 */
	_nts_2,	/* 184 */
	_nts_11,	/* 185 */
	_nts_1,	/* 186 */
	_nts_0,	/* 187 */
	_nts_1,	/* 188 */
	_nts_13,	/* 189 */
	_nts_0,	/* 190 */
	_nts_1,	/* 191 */
	_nts_13,	/* 192 */
	_nts_0,	/* 193 */
	_nts_36,	/* 194 */
	_nts_37,	/* 195 */
	_nts_37,	/* 196 */
	_nts_37,	/* 197 */
	_nts_37,	/* 198 */
	_nts_37,	/* 199 */
	_nts_37,	/* 200 */
	_nts_37,	/* 201 */
	_nts_37,	/* 202 */
	_nts_37,	/* 203 */
	_nts_37,	/* 204 */
	_nts_20,	/* 205 */
	_nts_20,	/* 206 */
	_nts_20,	/* 207 */
	_nts_20,	/* 208 */
	_nts_20,	/* 209 */
	_nts_20,	/* 210 */
	_nts_20,	/* 211 */
	_nts_20,	/* 212 */
	_nts_20,	/* 213 */
	_nts_20,	/* 214 */
	_nts_11,	/* 215 */
	_nts_11,	/* 216 */
	_nts_11,	/* 217 */
	_nts_2,	/* 218 */
	_nts_38,	/* 219 */
	_nts_38,	/* 220 */
	_nts_38,	/* 221 */
	_nts_38,	/* 222 */
	_nts_38,	/* 223 */
	_nts_38,	/* 224 */
	_nts_38,	/* 225 */
	_nts_38,	/* 226 */
	_nts_38,	/* 227 */
	_nts_38,	/* 228 */
	_nts_38,	/* 229 */
	_nts_38,	/* 230 */
	_nts_39,	/* 231 */
	_nts_39,	/* 232 */
	_nts_39,	/* 233 */
	_nts_39,	/* 234 */
	_nts_39,	/* 235 */
	_nts_39,	/* 236 */
	_nts_39,	/* 237 */
	_nts_39,	/* 238 */
	_nts_39,	/* 239 */
	_nts_39,	/* 240 */
	_nts_39,	/* 241 */
	_nts_39,	/* 242 */
	_nts_1,	/* 243 */
	_nts_2,	/* 244 */
	_nts_2,	/* 245 */
};

static char _arity[] = {
	0,	/* 0 */
	0,	/* 1 */
	0,	/* 2 */
	0,	/* 3 */
	0,	/* 4 */
	0,	/* 5 */
	0,	/* 6 */
	0,	/* 7 */
	0,	/* 8 */
	0,	/* 9 */
	0,	/* 10 */
	0,	/* 11 */
	0,	/* 12 */
	0,	/* 13 */
	0,	/* 14 */
	0,	/* 15 */
	0,	/* 16 */
	0,	/* 17=CNSTF */
	0,	/* 18=CNSTD */
	0,	/* 19=CNSTC */
	0,	/* 20=CNSTS */
	0,	/* 21=CNSTI */
	0,	/* 22=CNSTU */
	0,	/* 23=CNSTP */
	0,	/* 24 */
	0,	/* 25 */
	0,	/* 26 */
	0,	/* 27 */
	0,	/* 28 */
	0,	/* 29 */
	0,	/* 30 */
	0,	/* 31 */
	0,	/* 32 */
	1,	/* 33=ARGF */
	1,	/* 34=ARGD */
	0,	/* 35 */
	0,	/* 36 */
	1,	/* 37=ARGI */
	0,	/* 38 */
	1,	/* 39=ARGP */
	0,	/* 40 */
	1,	/* 41=ARGB */
	0,	/* 42 */
	0,	/* 43 */
	0,	/* 44 */
	0,	/* 45 */
	0,	/* 46 */
	0,	/* 47 */
	0,	/* 48 */
	2,	/* 49=ASGNF */
	2,	/* 50=ASGND */
	2,	/* 51=ASGNC */
	2,	/* 52=ASGNS */
	2,	/* 53=ASGNI */
	0,	/* 54 */
	2,	/* 55=ASGNP */
	0,	/* 56 */
	2,	/* 57=ASGNB */
	0,	/* 58 */
	0,	/* 59 */
	0,	/* 60 */
	0,	/* 61 */
	0,	/* 62 */
	0,	/* 63 */
	0,	/* 64 */
	1,	/* 65=INDIRF */
	1,	/* 66=INDIRD */
	1,	/* 67=INDIRC */
	1,	/* 68=INDIRS */
	1,	/* 69=INDIRI */
	0,	/* 70 */
	1,	/* 71=INDIRP */
	0,	/* 72 */
	1,	/* 73=INDIRB */
	0,	/* 74 */
	0,	/* 75 */
	0,	/* 76 */
	0,	/* 77 */
	0,	/* 78 */
	0,	/* 79 */
	0,	/* 80 */
	0,	/* 81 */
	0,	/* 82 */
	0,	/* 83 */
	0,	/* 84 */
	1,	/* 85=CVCI */
	1,	/* 86=CVCU */
	0,	/* 87 */
	0,	/* 88 */
	0,	/* 89 */
	0,	/* 90 */
	0,	/* 91 */
	0,	/* 92 */
	0,	/* 93 */
	0,	/* 94 */
	0,	/* 95 */
	0,	/* 96 */
	1,	/* 97=CVDF */
	0,	/* 98 */
	0,	/* 99 */
	0,	/* 100 */
	1,	/* 101=CVDI */
	0,	/* 102 */
	0,	/* 103 */
	0,	/* 104 */
	0,	/* 105 */
	0,	/* 106 */
	0,	/* 107 */
	0,	/* 108 */
	0,	/* 109 */
	0,	/* 110 */
	0,	/* 111 */
	0,	/* 112 */
	0,	/* 113 */
	1,	/* 114=CVFD */
	0,	/* 115 */
	0,	/* 116 */
	0,	/* 117 */
	0,	/* 118 */
	0,	/* 119 */
	0,	/* 120 */
	0,	/* 121 */
	0,	/* 122 */
	0,	/* 123 */
	0,	/* 124 */
	0,	/* 125 */
	0,	/* 126 */
	0,	/* 127 */
	0,	/* 128 */
	0,	/* 129 */
	1,	/* 130=CVID */
	1,	/* 131=CVIC */
	1,	/* 132=CVIS */
	0,	/* 133 */
	1,	/* 134=CVIU */
	0,	/* 135 */
	0,	/* 136 */
	0,	/* 137 */
	0,	/* 138 */
	0,	/* 139 */
	0,	/* 140 */
	0,	/* 141 */
	0,	/* 142 */
	0,	/* 143 */
	0,	/* 144 */
	0,	/* 145 */
	0,	/* 146 */
	0,	/* 147 */
	0,	/* 148 */
	0,	/* 149 */
	1,	/* 150=CVPU */
	0,	/* 151 */
	0,	/* 152 */
	0,	/* 153 */
	0,	/* 154 */
	0,	/* 155 */
	0,	/* 156 */
	0,	/* 157 */
	0,	/* 158 */
	0,	/* 159 */
	0,	/* 160 */
	0,	/* 161 */
	0,	/* 162 */
	0,	/* 163 */
	0,	/* 164 */
	1,	/* 165=CVSI */
	1,	/* 166=CVSU */
	0,	/* 167 */
	0,	/* 168 */
	0,	/* 169 */
	0,	/* 170 */
	0,	/* 171 */
	0,	/* 172 */
	0,	/* 173 */
	0,	/* 174 */
	0,	/* 175 */
	0,	/* 176 */
	0,	/* 177 */
	0,	/* 178 */
	1,	/* 179=CVUC */
	1,	/* 180=CVUS */
	1,	/* 181=CVUI */
	0,	/* 182 */
	1,	/* 183=CVUP */
	0,	/* 184 */
	0,	/* 185 */
	0,	/* 186 */
	0,	/* 187 */
	0,	/* 188 */
	0,	/* 189 */
	0,	/* 190 */
	0,	/* 191 */
	0,	/* 192 */
	1,	/* 193=NEGF */
	1,	/* 194=NEGD */
	0,	/* 195 */
	0,	/* 196 */
	1,	/* 197=NEGI */
	0,	/* 198 */
	0,	/* 199 */
	0,	/* 200 */
	0,	/* 201 */
	0,	/* 202 */
	0,	/* 203 */
	0,	/* 204 */
	0,	/* 205 */
	0,	/* 206 */
	0,	/* 207 */
	0,	/* 208 */
	1,	/* 209=CALLF */
	1,	/* 210=CALLD */
	0,	/* 211 */
	0,	/* 212 */
	1,	/* 213=CALLI */
	0,	/* 214 */
	0,	/* 215 */
	1,	/* 216=CALLV */
	0,	/* 217=CALLB */
	0,	/* 218 */
	0,	/* 219 */
	0,	/* 220 */
	0,	/* 221 */
	0,	/* 222 */
	0,	/* 223 */
	0,	/* 224 */
	0,	/* 225=LOADF */
	0,	/* 226=LOADD */
	1,	/* 227=LOADC */
	1,	/* 228=LOADS */
	1,	/* 229=LOADI */
	1,	/* 230=LOADU */
	1,	/* 231=LOADP */
	0,	/* 232 */
	0,	/* 233=LOADB */
	0,	/* 234 */
	0,	/* 235 */
	0,	/* 236 */
	0,	/* 237 */
	0,	/* 238 */
	0,	/* 239 */
	0,	/* 240 */
	1,	/* 241=RETF */
	1,	/* 242=RETD */
	0,	/* 243 */
	0,	/* 244 */
	1,	/* 245=RETI */
	0,	/* 246 */
	0,	/* 247 */
	0,	/* 248 */
	0,	/* 249 */
	0,	/* 250 */
	0,	/* 251 */
	0,	/* 252 */
	0,	/* 253 */
	0,	/* 254 */
	0,	/* 255 */
	0,	/* 256 */
	0,	/* 257 */
	0,	/* 258 */
	0,	/* 259 */
	0,	/* 260 */
	0,	/* 261 */
	0,	/* 262 */
	0,	/* 263=ADDRGP */
	0,	/* 264 */
	0,	/* 265 */
	0,	/* 266 */
	0,	/* 267 */
	0,	/* 268 */
	0,	/* 269 */
	0,	/* 270 */
	0,	/* 271 */
	0,	/* 272 */
	0,	/* 273 */
	0,	/* 274 */
	0,	/* 275 */
	0,	/* 276 */
	0,	/* 277 */
	0,	/* 278 */
	0,	/* 279=ADDRFP */
	0,	/* 280 */
	0,	/* 281 */
	0,	/* 282 */
	0,	/* 283 */
	0,	/* 284 */
	0,	/* 285 */
	0,	/* 286 */
	0,	/* 287 */
	0,	/* 288 */
	0,	/* 289 */
	0,	/* 290 */
	0,	/* 291 */
	0,	/* 292 */
	0,	/* 293 */
	0,	/* 294 */
	0,	/* 295=ADDRLP */
	0,	/* 296 */
	0,	/* 297 */
	0,	/* 298 */
	0,	/* 299 */
	0,	/* 300 */
	0,	/* 301 */
	0,	/* 302 */
	0,	/* 303 */
	0,	/* 304 */
	2,	/* 305=ADDF */
	2,	/* 306=ADDD */
	0,	/* 307 */
	0,	/* 308 */
	2,	/* 309=ADDI */
	2,	/* 310=ADDU */
	2,	/* 311=ADDP */
	0,	/* 312 */
	0,	/* 313 */
	0,	/* 314 */
	0,	/* 315 */
	0,	/* 316 */
	0,	/* 317 */
	0,	/* 318 */
	0,	/* 319 */
	0,	/* 320 */
	2,	/* 321=SUBF */
	2,	/* 322=SUBD */
	0,	/* 323 */
	0,	/* 324 */
	2,	/* 325=SUBI */
	2,	/* 326=SUBU */
	2,	/* 327=SUBP */
	0,	/* 328 */
	0,	/* 329 */
	0,	/* 330 */
	0,	/* 331 */
	0,	/* 332 */
	0,	/* 333 */
	0,	/* 334 */
	0,	/* 335 */
	0,	/* 336 */
	0,	/* 337 */
	0,	/* 338 */
	0,	/* 339 */
	0,	/* 340 */
	2,	/* 341=LSHI */
	2,	/* 342=LSHU */
	0,	/* 343 */
	0,	/* 344 */
	0,	/* 345 */
	0,	/* 346 */
	0,	/* 347 */
	0,	/* 348 */
	0,	/* 349 */
	0,	/* 350 */
	0,	/* 351 */
	0,	/* 352 */
	0,	/* 353 */
	0,	/* 354 */
	0,	/* 355 */
	0,	/* 356 */
	2,	/* 357=MODI */
	2,	/* 358=MODU */
	0,	/* 359 */
	0,	/* 360 */
	0,	/* 361 */
	0,	/* 362 */
	0,	/* 363 */
	0,	/* 364 */
	0,	/* 365 */
	0,	/* 366 */
	0,	/* 367 */
	0,	/* 368 */
	0,	/* 369 */
	0,	/* 370 */
	0,	/* 371 */
	0,	/* 372 */
	2,	/* 373=RSHI */
	2,	/* 374=RSHU */
	0,	/* 375 */
	0,	/* 376 */
	0,	/* 377 */
	0,	/* 378 */
	0,	/* 379 */
	0,	/* 380 */
	0,	/* 381 */
	0,	/* 382 */
	0,	/* 383 */
	0,	/* 384 */
	0,	/* 385 */
	0,	/* 386 */
	0,	/* 387 */
	0,	/* 388 */
	0,	/* 389 */
	2,	/* 390=BANDU */
	0,	/* 391 */
	0,	/* 392 */
	0,	/* 393 */
	0,	/* 394 */
	0,	/* 395 */
	0,	/* 396 */
	0,	/* 397 */
	0,	/* 398 */
	0,	/* 399 */
	0,	/* 400 */
	0,	/* 401 */
	0,	/* 402 */
	0,	/* 403 */
	0,	/* 404 */
	0,	/* 405 */
	1,	/* 406=BCOMU */
	0,	/* 407 */
	0,	/* 408 */
	0,	/* 409 */
	0,	/* 410 */
	0,	/* 411 */
	0,	/* 412 */
	0,	/* 413 */
	0,	/* 414 */
	0,	/* 415 */
	0,	/* 416 */
	0,	/* 417 */
	0,	/* 418 */
	0,	/* 419 */
	0,	/* 420 */
	0,	/* 421 */
	2,	/* 422=BORU */
	0,	/* 423 */
	0,	/* 424 */
	0,	/* 425 */
	0,	/* 426 */
	0,	/* 427 */
	0,	/* 428 */
	0,	/* 429 */
	0,	/* 430 */
	0,	/* 431 */
	0,	/* 432 */
	0,	/* 433 */
	0,	/* 434 */
	0,	/* 435 */
	0,	/* 436 */
	0,	/* 437 */
	2,	/* 438=BXORU */
	0,	/* 439 */
	0,	/* 440 */
	0,	/* 441 */
	0,	/* 442 */
	0,	/* 443 */
	0,	/* 444 */
	0,	/* 445 */
	0,	/* 446 */
	0,	/* 447 */
	0,	/* 448 */
	2,	/* 449=DIVF */
	2,	/* 450=DIVD */
	0,	/* 451 */
	0,	/* 452 */
	2,	/* 453=DIVI */
	2,	/* 454=DIVU */
	0,	/* 455 */
	0,	/* 456 */
	0,	/* 457 */
	0,	/* 458 */
	0,	/* 459 */
	0,	/* 460 */
	0,	/* 461 */
	0,	/* 462 */
	0,	/* 463 */
	0,	/* 464 */
	2,	/* 465=MULF */
	2,	/* 466=MULD */
	0,	/* 467 */
	0,	/* 468 */
	2,	/* 469=MULI */
	2,	/* 470=MULU */
	0,	/* 471 */
	0,	/* 472 */
	0,	/* 473 */
	0,	/* 474 */
	0,	/* 475 */
	0,	/* 476 */
	0,	/* 477 */
	0,	/* 478 */
	0,	/* 479 */
	0,	/* 480 */
	2,	/* 481=EQF */
	2,	/* 482=EQD */
	0,	/* 483 */
	0,	/* 484 */
	2,	/* 485=EQI */
	0,	/* 486 */
	0,	/* 487 */
	0,	/* 488 */
	0,	/* 489 */
	0,	/* 490 */
	0,	/* 491 */
	0,	/* 492 */
	0,	/* 493 */
	0,	/* 494 */
	0,	/* 495 */
	0,	/* 496 */
	2,	/* 497=GEF */
	2,	/* 498=GED */
	0,	/* 499 */
	0,	/* 500 */
	2,	/* 501=GEI */
	2,	/* 502=GEU */
	0,	/* 503 */
	0,	/* 504 */
	0,	/* 505 */
	0,	/* 506 */
	0,	/* 507 */
	0,	/* 508 */
	0,	/* 509 */
	0,	/* 510 */
	0,	/* 511 */
	0,	/* 512 */
	2,	/* 513=GTF */
	2,	/* 514=GTD */
	0,	/* 515 */
	0,	/* 516 */
	2,	/* 517=GTI */
	2,	/* 518=GTU */
	0,	/* 519 */
	0,	/* 520 */
	0,	/* 521 */
	0,	/* 522 */
	0,	/* 523 */
	0,	/* 524 */
	0,	/* 525 */
	0,	/* 526 */
	0,	/* 527 */
	0,	/* 528 */
	2,	/* 529=LEF */
	2,	/* 530=LED */
	0,	/* 531 */
	0,	/* 532 */
	2,	/* 533=LEI */
	2,	/* 534=LEU */
	0,	/* 535 */
	0,	/* 536 */
	0,	/* 537 */
	0,	/* 538 */
	0,	/* 539 */
	0,	/* 540 */
	0,	/* 541 */
	0,	/* 542 */
	0,	/* 543 */
	0,	/* 544 */
	2,	/* 545=LTF */
	2,	/* 546=LTD */
	0,	/* 547 */
	0,	/* 548 */
	2,	/* 549=LTI */
	2,	/* 550=LTU */
	0,	/* 551 */
	0,	/* 552 */
	0,	/* 553 */
	0,	/* 554 */
	0,	/* 555 */
	0,	/* 556 */
	0,	/* 557 */
	0,	/* 558 */
	0,	/* 559 */
	0,	/* 560 */
	2,	/* 561=NEF */
	2,	/* 562=NED */
	0,	/* 563 */
	0,	/* 564 */
	2,	/* 565=NEI */
	0,	/* 566 */
	0,	/* 567 */
	0,	/* 568 */
	0,	/* 569 */
	0,	/* 570 */
	0,	/* 571 */
	0,	/* 572 */
	0,	/* 573 */
	0,	/* 574 */
	0,	/* 575 */
	0,	/* 576 */
	0,	/* 577 */
	0,	/* 578 */
	0,	/* 579 */
	0,	/* 580 */
	0,	/* 581 */
	0,	/* 582 */
	0,	/* 583 */
	1,	/* 584=JUMPV */
	0,	/* 585 */
	0,	/* 586 */
	0,	/* 587 */
	0,	/* 588 */
	0,	/* 589 */
	0,	/* 590 */
	0,	/* 591 */
	0,	/* 592 */
	0,	/* 593 */
	0,	/* 594 */
	0,	/* 595 */
	0,	/* 596 */
	0,	/* 597 */
	0,	/* 598 */
	0,	/* 599 */
	0,	/* 600=LABELV */
	0,	/* 601 */
	0,	/* 602 */
	0,	/* 603 */
	0,	/* 604 */
	0,	/* 605 */
	0,	/* 606 */
	0,	/* 607 */
	0,	/* 608 */
	0,	/* 609 */
	0,	/* 610 */
	0,	/* 611 */
	0,	/* 612 */
	0,	/* 613 */
	0,	/* 614 */
	0,	/* 615=VREGP */
};

static char *_opname[] = {
/* 0 */	0,
/* 1 */	0,
/* 2 */	0,
/* 3 */	0,
/* 4 */	0,
/* 5 */	0,
/* 6 */	0,
/* 7 */	0,
/* 8 */	0,
/* 9 */	0,
/* 10 */	0,
/* 11 */	0,
/* 12 */	0,
/* 13 */	0,
/* 14 */	0,
/* 15 */	0,
/* 16 */	0,
/* 17 */	"CNSTF",
/* 18 */	"CNSTD",
/* 19 */	"CNSTC",
/* 20 */	"CNSTS",
/* 21 */	"CNSTI",
/* 22 */	"CNSTU",
/* 23 */	"CNSTP",
/* 24 */	0,
/* 25 */	0,
/* 26 */	0,
/* 27 */	0,
/* 28 */	0,
/* 29 */	0,
/* 30 */	0,
/* 31 */	0,
/* 32 */	0,
/* 33 */	"ARGF",
/* 34 */	"ARGD",
/* 35 */	0,
/* 36 */	0,
/* 37 */	"ARGI",
/* 38 */	0,
/* 39 */	"ARGP",
/* 40 */	0,
/* 41 */	"ARGB",
/* 42 */	0,
/* 43 */	0,
/* 44 */	0,
/* 45 */	0,
/* 46 */	0,
/* 47 */	0,
/* 48 */	0,
/* 49 */	"ASGNF",
/* 50 */	"ASGND",
/* 51 */	"ASGNC",
/* 52 */	"ASGNS",
/* 53 */	"ASGNI",
/* 54 */	0,
/* 55 */	"ASGNP",
/* 56 */	0,
/* 57 */	"ASGNB",
/* 58 */	0,
/* 59 */	0,
/* 60 */	0,
/* 61 */	0,
/* 62 */	0,
/* 63 */	0,
/* 64 */	0,
/* 65 */	"INDIRF",
/* 66 */	"INDIRD",
/* 67 */	"INDIRC",
/* 68 */	"INDIRS",
/* 69 */	"INDIRI",
/* 70 */	0,
/* 71 */	"INDIRP",
/* 72 */	0,
/* 73 */	"INDIRB",
/* 74 */	0,
/* 75 */	0,
/* 76 */	0,
/* 77 */	0,
/* 78 */	0,
/* 79 */	0,
/* 80 */	0,
/* 81 */	0,
/* 82 */	0,
/* 83 */	0,
/* 84 */	0,
/* 85 */	"CVCI",
/* 86 */	"CVCU",
/* 87 */	0,
/* 88 */	0,
/* 89 */	0,
/* 90 */	0,
/* 91 */	0,
/* 92 */	0,
/* 93 */	0,
/* 94 */	0,
/* 95 */	0,
/* 96 */	0,
/* 97 */	"CVDF",
/* 98 */	0,
/* 99 */	0,
/* 100 */	0,
/* 101 */	"CVDI",
/* 102 */	0,
/* 103 */	0,
/* 104 */	0,
/* 105 */	0,
/* 106 */	0,
/* 107 */	0,
/* 108 */	0,
/* 109 */	0,
/* 110 */	0,
/* 111 */	0,
/* 112 */	0,
/* 113 */	0,
/* 114 */	"CVFD",
/* 115 */	0,
/* 116 */	0,
/* 117 */	0,
/* 118 */	0,
/* 119 */	0,
/* 120 */	0,
/* 121 */	0,
/* 122 */	0,
/* 123 */	0,
/* 124 */	0,
/* 125 */	0,
/* 126 */	0,
/* 127 */	0,
/* 128 */	0,
/* 129 */	0,
/* 130 */	"CVID",
/* 131 */	"CVIC",
/* 132 */	"CVIS",
/* 133 */	0,
/* 134 */	"CVIU",
/* 135 */	0,
/* 136 */	0,
/* 137 */	0,
/* 138 */	0,
/* 139 */	0,
/* 140 */	0,
/* 141 */	0,
/* 142 */	0,
/* 143 */	0,
/* 144 */	0,
/* 145 */	0,
/* 146 */	0,
/* 147 */	0,
/* 148 */	0,
/* 149 */	0,
/* 150 */	"CVPU",
/* 151 */	0,
/* 152 */	0,
/* 153 */	0,
/* 154 */	0,
/* 155 */	0,
/* 156 */	0,
/* 157 */	0,
/* 158 */	0,
/* 159 */	0,
/* 160 */	0,
/* 161 */	0,
/* 162 */	0,
/* 163 */	0,
/* 164 */	0,
/* 165 */	"CVSI",
/* 166 */	"CVSU",
/* 167 */	0,
/* 168 */	0,
/* 169 */	0,
/* 170 */	0,
/* 171 */	0,
/* 172 */	0,
/* 173 */	0,
/* 174 */	0,
/* 175 */	0,
/* 176 */	0,
/* 177 */	0,
/* 178 */	0,
/* 179 */	"CVUC",
/* 180 */	"CVUS",
/* 181 */	"CVUI",
/* 182 */	0,
/* 183 */	"CVUP",
/* 184 */	0,
/* 185 */	0,
/* 186 */	0,
/* 187 */	0,
/* 188 */	0,
/* 189 */	0,
/* 190 */	0,
/* 191 */	0,
/* 192 */	0,
/* 193 */	"NEGF",
/* 194 */	"NEGD",
/* 195 */	0,
/* 196 */	0,
/* 197 */	"NEGI",
/* 198 */	0,
/* 199 */	0,
/* 200 */	0,
/* 201 */	0,
/* 202 */	0,
/* 203 */	0,
/* 204 */	0,
/* 205 */	0,
/* 206 */	0,
/* 207 */	0,
/* 208 */	0,
/* 209 */	"CALLF",
/* 210 */	"CALLD",
/* 211 */	0,
/* 212 */	0,
/* 213 */	"CALLI",
/* 214 */	0,
/* 215 */	0,
/* 216 */	"CALLV",
/* 217 */	"CALLB",
/* 218 */	0,
/* 219 */	0,
/* 220 */	0,
/* 221 */	0,
/* 222 */	0,
/* 223 */	0,
/* 224 */	0,
/* 225 */	"LOADF",
/* 226 */	"LOADD",
/* 227 */	"LOADC",
/* 228 */	"LOADS",
/* 229 */	"LOADI",
/* 230 */	"LOADU",
/* 231 */	"LOADP",
/* 232 */	0,
/* 233 */	"LOADB",
/* 234 */	0,
/* 235 */	0,
/* 236 */	0,
/* 237 */	0,
/* 238 */	0,
/* 239 */	0,
/* 240 */	0,
/* 241 */	"RETF",
/* 242 */	"RETD",
/* 243 */	0,
/* 244 */	0,
/* 245 */	"RETI",
/* 246 */	0,
/* 247 */	0,
/* 248 */	0,
/* 249 */	0,
/* 250 */	0,
/* 251 */	0,
/* 252 */	0,
/* 253 */	0,
/* 254 */	0,
/* 255 */	0,
/* 256 */	0,
/* 257 */	0,
/* 258 */	0,
/* 259 */	0,
/* 260 */	0,
/* 261 */	0,
/* 262 */	0,
/* 263 */	"ADDRGP",
/* 264 */	0,
/* 265 */	0,
/* 266 */	0,
/* 267 */	0,
/* 268 */	0,
/* 269 */	0,
/* 270 */	0,
/* 271 */	0,
/* 272 */	0,
/* 273 */	0,
/* 274 */	0,
/* 275 */	0,
/* 276 */	0,
/* 277 */	0,
/* 278 */	0,
/* 279 */	"ADDRFP",
/* 280 */	0,
/* 281 */	0,
/* 282 */	0,
/* 283 */	0,
/* 284 */	0,
/* 285 */	0,
/* 286 */	0,
/* 287 */	0,
/* 288 */	0,
/* 289 */	0,
/* 290 */	0,
/* 291 */	0,
/* 292 */	0,
/* 293 */	0,
/* 294 */	0,
/* 295 */	"ADDRLP",
/* 296 */	0,
/* 297 */	0,
/* 298 */	0,
/* 299 */	0,
/* 300 */	0,
/* 301 */	0,
/* 302 */	0,
/* 303 */	0,
/* 304 */	0,
/* 305 */	"ADDF",
/* 306 */	"ADDD",
/* 307 */	0,
/* 308 */	0,
/* 309 */	"ADDI",
/* 310 */	"ADDU",
/* 311 */	"ADDP",
/* 312 */	0,
/* 313 */	0,
/* 314 */	0,
/* 315 */	0,
/* 316 */	0,
/* 317 */	0,
/* 318 */	0,
/* 319 */	0,
/* 320 */	0,
/* 321 */	"SUBF",
/* 322 */	"SUBD",
/* 323 */	0,
/* 324 */	0,
/* 325 */	"SUBI",
/* 326 */	"SUBU",
/* 327 */	"SUBP",
/* 328 */	0,
/* 329 */	0,
/* 330 */	0,
/* 331 */	0,
/* 332 */	0,
/* 333 */	0,
/* 334 */	0,
/* 335 */	0,
/* 336 */	0,
/* 337 */	0,
/* 338 */	0,
/* 339 */	0,
/* 340 */	0,
/* 341 */	"LSHI",
/* 342 */	"LSHU",
/* 343 */	0,
/* 344 */	0,
/* 345 */	0,
/* 346 */	0,
/* 347 */	0,
/* 348 */	0,
/* 349 */	0,
/* 350 */	0,
/* 351 */	0,
/* 352 */	0,
/* 353 */	0,
/* 354 */	0,
/* 355 */	0,
/* 356 */	0,
/* 357 */	"MODI",
/* 358 */	"MODU",
/* 359 */	0,
/* 360 */	0,
/* 361 */	0,
/* 362 */	0,
/* 363 */	0,
/* 364 */	0,
/* 365 */	0,
/* 366 */	0,
/* 367 */	0,
/* 368 */	0,
/* 369 */	0,
/* 370 */	0,
/* 371 */	0,
/* 372 */	0,
/* 373 */	"RSHI",
/* 374 */	"RSHU",
/* 375 */	0,
/* 376 */	0,
/* 377 */	0,
/* 378 */	0,
/* 379 */	0,
/* 380 */	0,
/* 381 */	0,
/* 382 */	0,
/* 383 */	0,
/* 384 */	0,
/* 385 */	0,
/* 386 */	0,
/* 387 */	0,
/* 388 */	0,
/* 389 */	0,
/* 390 */	"BANDU",
/* 391 */	0,
/* 392 */	0,
/* 393 */	0,
/* 394 */	0,
/* 395 */	0,
/* 396 */	0,
/* 397 */	0,
/* 398 */	0,
/* 399 */	0,
/* 400 */	0,
/* 401 */	0,
/* 402 */	0,
/* 403 */	0,
/* 404 */	0,
/* 405 */	0,
/* 406 */	"BCOMU",
/* 407 */	0,
/* 408 */	0,
/* 409 */	0,
/* 410 */	0,
/* 411 */	0,
/* 412 */	0,
/* 413 */	0,
/* 414 */	0,
/* 415 */	0,
/* 416 */	0,
/* 417 */	0,
/* 418 */	0,
/* 419 */	0,
/* 420 */	0,
/* 421 */	0,
/* 422 */	"BORU",
/* 423 */	0,
/* 424 */	0,
/* 425 */	0,
/* 426 */	0,
/* 427 */	0,
/* 428 */	0,
/* 429 */	0,
/* 430 */	0,
/* 431 */	0,
/* 432 */	0,
/* 433 */	0,
/* 434 */	0,
/* 435 */	0,
/* 436 */	0,
/* 437 */	0,
/* 438 */	"BXORU",
/* 439 */	0,
/* 440 */	0,
/* 441 */	0,
/* 442 */	0,
/* 443 */	0,
/* 444 */	0,
/* 445 */	0,
/* 446 */	0,
/* 447 */	0,
/* 448 */	0,
/* 449 */	"DIVF",
/* 450 */	"DIVD",
/* 451 */	0,
/* 452 */	0,
/* 453 */	"DIVI",
/* 454 */	"DIVU",
/* 455 */	0,
/* 456 */	0,
/* 457 */	0,
/* 458 */	0,
/* 459 */	0,
/* 460 */	0,
/* 461 */	0,
/* 462 */	0,
/* 463 */	0,
/* 464 */	0,
/* 465 */	"MULF",
/* 466 */	"MULD",
/* 467 */	0,
/* 468 */	0,
/* 469 */	"MULI",
/* 470 */	"MULU",
/* 471 */	0,
/* 472 */	0,
/* 473 */	0,
/* 474 */	0,
/* 475 */	0,
/* 476 */	0,
/* 477 */	0,
/* 478 */	0,
/* 479 */	0,
/* 480 */	0,
/* 481 */	"EQF",
/* 482 */	"EQD",
/* 483 */	0,
/* 484 */	0,
/* 485 */	"EQI",
/* 486 */	0,
/* 487 */	0,
/* 488 */	0,
/* 489 */	0,
/* 490 */	0,
/* 491 */	0,
/* 492 */	0,
/* 493 */	0,
/* 494 */	0,
/* 495 */	0,
/* 496 */	0,
/* 497 */	"GEF",
/* 498 */	"GED",
/* 499 */	0,
/* 500 */	0,
/* 501 */	"GEI",
/* 502 */	"GEU",
/* 503 */	0,
/* 504 */	0,
/* 505 */	0,
/* 506 */	0,
/* 507 */	0,
/* 508 */	0,
/* 509 */	0,
/* 510 */	0,
/* 511 */	0,
/* 512 */	0,
/* 513 */	"GTF",
/* 514 */	"GTD",
/* 515 */	0,
/* 516 */	0,
/* 517 */	"GTI",
/* 518 */	"GTU",
/* 519 */	0,
/* 520 */	0,
/* 521 */	0,
/* 522 */	0,
/* 523 */	0,
/* 524 */	0,
/* 525 */	0,
/* 526 */	0,
/* 527 */	0,
/* 528 */	0,
/* 529 */	"LEF",
/* 530 */	"LED",
/* 531 */	0,
/* 532 */	0,
/* 533 */	"LEI",
/* 534 */	"LEU",
/* 535 */	0,
/* 536 */	0,
/* 537 */	0,
/* 538 */	0,
/* 539 */	0,
/* 540 */	0,
/* 541 */	0,
/* 542 */	0,
/* 543 */	0,
/* 544 */	0,
/* 545 */	"LTF",
/* 546 */	"LTD",
/* 547 */	0,
/* 548 */	0,
/* 549 */	"LTI",
/* 550 */	"LTU",
/* 551 */	0,
/* 552 */	0,
/* 553 */	0,
/* 554 */	0,
/* 555 */	0,
/* 556 */	0,
/* 557 */	0,
/* 558 */	0,
/* 559 */	0,
/* 560 */	0,
/* 561 */	"NEF",
/* 562 */	"NED",
/* 563 */	0,
/* 564 */	0,
/* 565 */	"NEI",
/* 566 */	0,
/* 567 */	0,
/* 568 */	0,
/* 569 */	0,
/* 570 */	0,
/* 571 */	0,
/* 572 */	0,
/* 573 */	0,
/* 574 */	0,
/* 575 */	0,
/* 576 */	0,
/* 577 */	0,
/* 578 */	0,
/* 579 */	0,
/* 580 */	0,
/* 581 */	0,
/* 582 */	0,
/* 583 */	0,
/* 584 */	"JUMPV",
/* 585 */	0,
/* 586 */	0,
/* 587 */	0,
/* 588 */	0,
/* 589 */	0,
/* 590 */	0,
/* 591 */	0,
/* 592 */	0,
/* 593 */	0,
/* 594 */	0,
/* 595 */	0,
/* 596 */	0,
/* 597 */	0,
/* 598 */	0,
/* 599 */	0,
/* 600 */	"LABELV",
/* 601 */	0,
/* 602 */	0,
/* 603 */	0,
/* 604 */	0,
/* 605 */	0,
/* 606 */	0,
/* 607 */	0,
/* 608 */	0,
/* 609 */	0,
/* 610 */	0,
/* 611 */	0,
/* 612 */	0,
/* 613 */	0,
/* 614 */	0,
/* 615 */	"VREGP",
};

static char *_templates[] = {
/* 0 */	0,
/* 1 */	"# read register\n",	/* reg: INDIRC(VREGP) */
/* 2 */	"# read register\n",	/* reg: INDIRI(VREGP) */
/* 3 */	"# read register\n",	/* reg: INDIRP(VREGP) */
/* 4 */	"# read register\n",	/* reg: INDIRS(VREGP) */
/* 5 */	"# read register\n",	/* freg: INDIRD(VREGP) */
/* 6 */	"# read register\n",	/* freg: INDIRF(VREGP) */
/* 7 */	"# write register\n",	/* stmt: ASGNC(VREGP,reg) */
/* 8 */	"# write register\n",	/* stmt: ASGNI(VREGP,reg) */
/* 9 */	"# write register\n",	/* stmt: ASGNP(VREGP,reg) */
/* 10 */	"# write register\n",	/* stmt: ASGNS(VREGP,reg) */
/* 11 */	"# write register\n",	/* stmt: ASGND(VREGP,freg) */
/* 12 */	"# write register\n",	/* stmt: ASGNF(VREGP,freg) */
/* 13 */	"$%a",	/* con: CNSTC */
/* 14 */	"$%a",	/* con: CNSTI */
/* 15 */	"$%a",	/* con: CNSTP */
/* 16 */	"$%a",	/* con: CNSTS */
/* 17 */	"$%a",	/* con: CNSTU */
/* 18 */	"",	/* stmt: reg */
/* 19 */	"",	/* stmt: freg */
/* 20 */	"%0",	/* reg: CVIU(reg) */
/* 21 */	"%0",	/* reg: CVPU(reg) */
/* 22 */	"%0",	/* reg: CVUI(reg) */
/* 23 */	"%0",	/* reg: CVUP(reg) */
/* 24 */	"%a",	/* acon: ADDRGP */
/* 25 */	"%a",	/* acon: CNSTC */
/* 26 */	"%a",	/* acon: CNSTI */
/* 27 */	"%a",	/* acon: CNSTP */
/* 28 */	"%a",	/* acon: CNSTS */
/* 29 */	"%a",	/* acon: CNSTU */
/* 30 */	"%a",	/* baseaddr: ADDRGP */
/* 31 */	"(%0)",	/* base: reg */
/* 32 */	"%1(%0)",	/* base: ADDI(reg,acon) */
/* 33 */	"%1(%0)",	/* base: ADDP(reg,acon) */
/* 34 */	"%1(%0)",	/* base: ADDU(reg,acon) */
/* 35 */	"%a(%%ebp)",	/* base: ADDRFP */
/* 36 */	"%a(%%ebp)",	/* base: ADDRLP */
/* 37 */	"1",	/* con1: CNSTI */
/* 38 */	"1",	/* con1: CNSTU */
/* 39 */	"2",	/* icon: CNSTI */
/* 40 */	"2",	/* icon: CNSTU */
/* 41 */	"4",	/* icon: CNSTI */
/* 42 */	"4",	/* icon: CNSTU */
/* 43 */	"8",	/* icon: CNSTI */
/* 44 */	"8",	/* icon: CNSTU */
/* 45 */	"%0",	/* index: reg */
/* 46 */	"%0,%1",	/* index: LSHI(reg,icon) */
/* 47 */	"%0,%1",	/* index: LSHU(reg,icon) */
/* 48 */	"%0",	/* addr: base */
/* 49 */	"%0",	/* addr: baseaddr */
/* 50 */	"%1(,%0)",	/* addr: ADDI(index,baseaddr) */
/* 51 */	"%1(%0)",	/* addr: ADDI(reg,baseaddr) */
/* 52 */	"(%1,%0)",	/* addr: ADDI(index,reg) */
/* 53 */	"%1(,%0)",	/* addr: ADDP(index,baseaddr) */
/* 54 */	"%1(%0)",	/* addr: ADDP(reg,baseaddr) */
/* 55 */	"(%1,%0)",	/* addr: ADDP(index,reg) */
/* 56 */	"%1(,%0)",	/* addr: ADDU(index,baseaddr) */
/* 57 */	"%1(%0)",	/* addr: ADDU(reg,baseaddr) */
/* 58 */	"(%1,%0)",	/* addr: ADDU(index,reg) */
/* 59 */	"(,%0)",	/* addr: index */
/* 60 */	"%0",	/* memb: INDIRC(addr) */
/* 61 */	"%0",	/* memw: INDIRS(addr) */
/* 62 */	"%0",	/* mem: INDIRI(addr) */
/* 63 */	"%0",	/* mem: INDIRP(addr) */
/* 64 */	"$%a",	/* rc5: CNSTI */
/* 65 */	"%%cl",	/* rc5: reg */
/* 66 */	"%0",	/* rc: reg */
/* 67 */	"%0",	/* rc: con */
/* 68 */	"%0",	/* mr: reg */
/* 69 */	"%0",	/* mr: mem */
/* 70 */	"%0",	/* mrb: reg */
/* 71 */	"%0",	/* mrb: memb */
/* 72 */	"%0",	/* mrw: reg */
/* 73 */	"%0",	/* mrw: memw */
/* 74 */	"%0",	/* mrc: mem */
/* 75 */	"%0",	/* mrc: memb */
/* 76 */	"%0",	/* mrc: memw */
/* 77 */	"%0",	/* mrc: rc */
/* 78 */	"\tleal\t%0,%c\n",	/* reg: addr */
/* 79 */	"\tmovl\t%0,%c\n",	/* reg: mr */
/* 80 */	"\tmovb\t%0,%c\n",	/* reg: mrb */
/* 81 */	"\tmovw\t%0,%c\n",	/* reg: mrw */
/* 82 */	"\tmovl\t%0,%c\n",	/* reg: con */
/* 83 */	"\tmovb\t%0,%c\n",	/* reg: LOADC(reg) */
/* 84 */	"\tmovl\t%0,%c\n",	/* reg: LOADI(reg) */
/* 85 */	"\tmovl\t%0,%c\n",	/* reg: LOADP(reg) */
/* 86 */	"\tmovw\t%0,%c\n",	/* reg: LOADS(reg) */
/* 87 */	"\tmovl\t%0,%c\n",	/* reg: LOADU(reg) */
/* 88 */	"?\tmovl\t%0,%c\n\taddl\t%1,%c\n",	/* reg: ADDI(reg,mrc) */
/* 89 */	"?\tmovl\t%0,%c\n\taddl\t%1,%c\n",	/* reg: ADDP(reg,mrc) */
/* 90 */	"?\tmovl\t%0,%c\n\taddl\t%1,%c\n",	/* reg: ADDU(reg,mrc) */
/* 91 */	"?\tmovl\t%0,%c\n\tsubl\t%1,%c\n",	/* reg: SUBI(reg,mrc) */
/* 92 */	"?\tmovl\t%0,%c\n\tsubl\t%1,%c\n",	/* reg: SUBP(reg,mrc) */
/* 93 */	"?\tmovl\t%0,%c\n\tsubl\t%1,%c\n",	/* reg: SUBU(reg,mrc) */
/* 94 */	"?\tmovl\t%0,%c\n\tandl\t%1,%c\n",	/* reg: BANDU(reg,mrc) */
/* 95 */	"?\tmovl\t%0,%c\n\torl\t%1,%c\n",	/* reg: BORU(reg,mrc) */
/* 96 */	"?\tmovl\t%0,%c\n\txorl\t%1,%c\n",	/* reg: BXORU(reg,mrc) */
/* 97 */	"?\tmovl\t%0,%c\n\tsall\t%1,%c\n",	/* reg: LSHI(reg,rc5) */
/* 98 */	"?\tmovl\t%0,%c\n\tshll\t%1,%c\n",	/* reg: LSHU(reg,rc5) */
/* 99 */	"?\tmovl\t%0,%c\n\tsarl\t%1,%c\n",	/* reg: RSHI(reg,rc5) */
/* 100 */	"?\tmovl\t%0,%c\n\tshrl\t%1,%c\n",	/* reg: RSHU(reg,rc5) */
/* 101 */	"?\tmovl\t%0,%c\n\tnotl\t%c\n",	/* reg: BCOMU(reg) */
/* 102 */	"?\tmovl\t%0,%c\n\tnegl\t%c\n",	/* reg: NEGI(reg) */
/* 103 */	"\tincl\t%1\n",	/* stmt: ASGNI(addr,ADDI(mem,con1)) */
/* 104 */	"\tincl\t%1\n",	/* stmt: ASGNI(addr,ADDU(mem,con1)) */
/* 105 */	"\tincl\t%1\n",	/* stmt: ASGNP(addr,ADDP(mem,con1)) */
/* 106 */	"\tdecl\t%1\n",	/* stmt: ASGNI(addr,SUBI(mem,con1)) */
/* 107 */	"\tdecl\t%1\n",	/* stmt: ASGNI(addr,SUBU(mem,con1)) */
/* 108 */	"\tdecl\t%1\n",	/* stmt: ASGNP(addr,SUBP(mem,con1)) */
/* 109 */	"\taddl\t%2,%1\n",	/* stmt: ASGNI(addr,ADDI(mem,rc)) */
/* 110 */	"\taddl\t%2,%1\n",	/* stmt: ASGNI(addr,ADDU(mem,rc)) */
/* 111 */	"\tsubl\t%2,%1\n",	/* stmt: ASGNI(addr,SUBI(mem,rc)) */
/* 112 */	"\tsubl\t%2,%1\n",	/* stmt: ASGNI(addr,SUBU(mem,rc)) */
/* 113 */	"\tandl\t%2,%1\n",	/* stmt: ASGNI(addr,BANDU(mem,rc)) */
/* 114 */	"\torl\t%2,%1\n",	/* stmt: ASGNI(addr,BORU(mem,rc)) */
/* 115 */	"\txorl\t%2,%1\n",	/* stmt: ASGNI(addr,BXORU(mem,rc)) */
/* 116 */	"\tnotl\t%1\n",	/* stmt: ASGNI(addr,BCOMU(mem)) */
/* 117 */	"\tnegl\t%1\n",	/* stmt: ASGNI(addr,NEGI(mem)) */
/* 118 */	"\tsall\t%2,%1\n",	/* stmt: ASGNI(addr,LSHI(mem,rc5)) */
/* 119 */	"\tshll\t%2,%1\n",	/* stmt: ASGNI(addr,LSHU(mem,rc5)) */
/* 120 */	"\tsarl\t%2,%1\n",	/* stmt: ASGNI(addr,RSHI(mem,rc5)) */
/* 121 */	"\tshrl\t%2,%1\n",	/* stmt: ASGNI(addr,RSHU(mem,rc5)) */
/* 122 */	"?\tmovl\t%0,%c\n\timull\t%1,%c\n",	/* reg: MULI(reg,mrc) */
/* 123 */	"\timul\t%0,%1,%c\n",	/* reg: MULI(con,mr) */
/* 124 */	"\tmull\t%1\n",	/* reg: MULU(reg,mr) */
/* 125 */	"\txorl\t%%edx,%%edx\n\tdivl\t%1\n",	/* reg: DIVU(reg,reg) */
/* 126 */	"\txorl\t%%edx,%%edx\n\tdivl\t%1\n",	/* reg: MODU(reg,reg) */
/* 127 */	"\tcdq\n\tidivl\t%1\n",	/* reg: DIVI(reg,reg) */
/* 128 */	"\tcdq\n\tidivl\t%1\n",	/* reg: MODI(reg,reg) */
/* 129 */	"\tmovl\t%0,%c\n",	/* reg: CVIU(reg) */
/* 130 */	"\tmovl\t%0,%c\n",	/* reg: CVPU(reg) */
/* 131 */	"\tmovl\t%0,%c\n",	/* reg: CVUI(reg) */
/* 132 */	"\tmovl\t%0,%c\n",	/* reg: CVUP(reg) */
/* 133 */	"\tmovsbl\t%0,%c\n",	/* reg: CVCI(INDIRC(addr)) */
/* 134 */	"\tmovzbl\t%0,%c\n",	/* reg: CVCU(INDIRC(addr)) */
/* 135 */	"\tmovswl\t%0,%c\n",	/* reg: CVSI(INDIRS(addr)) */
/* 136 */	"\tmovzwl\t%0,%c\n",	/* reg: CVSU(INDIRS(addr)) */
/* 137 */	"# extend\n",	/* reg: CVCI(reg) */
/* 138 */	"# extend\n",	/* reg: CVCU(reg) */
/* 139 */	"# extend\n",	/* reg: CVSI(reg) */
/* 140 */	"# extend\n",	/* reg: CVSU(reg) */
/* 141 */	"# truncate\n",	/* reg: CVIC(reg) */
/* 142 */	"# truncate\n",	/* reg: CVIS(reg) */
/* 143 */	"# truncate\n",	/* reg: CVUC(reg) */
/* 144 */	"# truncate\n",	/* reg: CVUS(reg) */
/* 145 */	"%0",	/* mrca: mem */
/* 146 */	"%0",	/* mrca: rc */
/* 147 */	"$%a",	/* mrca: ADDRGP */
/* 148 */	"\tmovb\t%1,%0\n",	/* stmt: ASGNC(addr,rc) */
/* 149 */	"\tmovl\t%1,%0\n",	/* stmt: ASGNI(addr,rc) */
/* 150 */	"\tmovl\t%1,%0\n",	/* stmt: ASGNP(addr,rc) */
/* 151 */	"\tmovw\t%1,%0\n",	/* stmt: ASGNS(addr,rc) */
/* 152 */	"\tmovl\t$%a,%%ecx\n\trep\n\tmovsb\n",	/* stmt: ASGNB(reg,INDIRB(reg)) */
/* 153 */	"\tpushl\t%0\n",	/* stmt: ARGI(mrca) */
/* 154 */	"\tpushl\t%0\n",	/* stmt: ARGP(mrca) */
/* 155 */	"\tsubl\t$%a,%%esp\n\tmovl\t%%esp,%%edi\n\tmovl\t$%b,%%ecx\n\trep\n\tmovsb\n",	/* stmt: ARGB(INDIRB(reg)) */
/* 156 */	"l\t%0",	/* memf: INDIRD(addr) */
/* 157 */	"s\t%0",	/* memf: INDIRF(addr) */
/* 158 */	"s\t%0",	/* memf: CVFD(INDIRF(addr)) */
/* 159 */	"\tfld%0\n",	/* freg: memf */
/* 160 */	"\tfstpl\t%0\n",	/* stmt: ASGND(addr,freg) */
/* 161 */	"\tfstps\t%0\n",	/* stmt: ASGNF(addr,freg) */
/* 162 */	"\tfstps\t%0\n",	/* stmt: ASGNF(addr,CVDF(freg)) */
/* 163 */	"\tsubl\t$8,%%esp\n\tfstpl\t(%%esp)\n",	/* stmt: ARGD(freg) */
/* 164 */	"\tsubl\t$4,%%esp\n\tfstps\t(%%esp)\n",	/* stmt: ARGF(freg) */
/* 165 */	"\tfchs\n",	/* freg: NEGD(freg) */
/* 166 */	"\tfchs\n",	/* freg: NEGF(freg) */
/* 167 */	"%0",	/* flt: memf */
/* 168 */	"p\t%%st,%%st(1)",	/* flt: freg */
/* 169 */	"\tfadd%1\n",	/* freg: ADDD(freg,flt) */
/* 170 */	"\tfadd%1\n",	/* freg: ADDF(freg,flt) */
/* 171 */	"\tfdiv%1\n",	/* freg: DIVD(freg,memf) */
/* 172 */	"\tfdivrp\t%%st,%%st(1)\n",	/* freg: DIVD(freg,freg) */
/* 173 */	"\tfdiv%1\n",	/* freg: DIVF(freg,memf) */
/* 174 */	"\tfdivrp\t%%st,%%st(1)\n",	/* freg: DIVF(freg,freg) */
/* 175 */	"\tfmul%1\n",	/* freg: MULD(freg,flt) */
/* 176 */	"\tfmul%1\n",	/* freg: MULF(freg,flt) */
/* 177 */	"\tfsub%1\n",	/* freg: SUBD(freg,memf) */
/* 178 */	"\tfsubrp\t%%st,%%st(1)\n",	/* freg: SUBD(freg,freg) */
/* 179 */	"\tfsub%1\n",	/* freg: SUBF(freg,memf) */
/* 180 */	"\tfsubrp\t%%st,%%st(1)\n",	/* freg: SUBF(freg,freg) */
/* 181 */	"# CVFD\n",	/* freg: CVFD(freg) */
/* 182 */	"\tsub\t$4,%%esp ; fstps (%%esp); flds (%%esp); addl $4,%%esp\n",	/* freg: CVDF(freg) */
/* 183 */	"\t.extern\t__ftol\n\tcall\t__ftol\n\tmovl\t%%eax,%0\n",	/* stmt: ASGNI(addr,CVDI(freg)) */
/* 184 */	"\t.extern\t__ftol\n\tcall\t__ftol\n\tmovl\t%%eax,%c\n",	/* reg: CVDI(freg) */
/* 185 */	"\tfildl\t%0\n",	/* freg: CVID(INDIRI(addr)) */
/* 186 */	"\tpushl\t%0\n\tfildl\t(%%esp)\n\taddl\t$4,%%esp\n",	/* freg: CVID(reg) */
/* 187 */	"%a",	/* addrj: ADDRGP */
/* 188 */	"*%0",	/* addrj: reg */
/* 189 */	"*%0",	/* addrj: mem */
/* 190 */	"%a",	/* addrjmp: ADDRGP */
/* 191 */	"*%0",	/* addrjmp: reg */
/* 192 */	"*%0",	/* addrjmp: mem */
/* 193 */	"%a:\n",	/* stmt: LABELV */
/* 194 */	"\tjmp\t%0\n",	/* stmt: JUMPV(addrjmp) */
/* 195 */	"\tcmpl\t%1,%0\n\tje\t%a\n",	/* stmt: EQI(mem,rc) */
/* 196 */	"\tcmpl\t%1,%0\n\tjge\t%a\n",	/* stmt: GEI(mem,rc) */
/* 197 */	"\tcmpl\t%1,%0\n\tjg\t%a\n",	/* stmt: GTI(mem,rc) */
/* 198 */	"\tcmpl\t%1,%0\n\tjle\t%a\n",	/* stmt: LEI(mem,rc) */
/* 199 */	"\tcmpl\t%1,%0\n\tjl\t%a\n",	/* stmt: LTI(mem,rc) */
/* 200 */	"\tcmpl\t%1,%0\n\tjne\t%a\n",	/* stmt: NEI(mem,rc) */
/* 201 */	"\tcmpl\t%1,%0\n\tjae\t%a\n",	/* stmt: GEU(mem,rc) */
/* 202 */	"\tcmpl\t%1,%0\n\tja \t%a\n",	/* stmt: GTU(mem,rc) */
/* 203 */	"\tcmpl\t%1,%0\n\tjbe\t%a\n",	/* stmt: LEU(mem,rc) */
/* 204 */	"\tcmpl\t%1,%0\n\tjb \t%a\n",	/* stmt: LTU(mem,rc) */
/* 205 */	"\tcmpl\t%1,%0\n\tje\t%a\n",	/* stmt: EQI(reg,mrc) */
/* 206 */	"\tcmpl\t%1,%0\n\tjge\t%a\n",	/* stmt: GEI(reg,mrc) */
/* 207 */	"\tcmpl\t%1,%0\n\tjg\t%a\n",	/* stmt: GTI(reg,mrc) */
/* 208 */	"\tcmpl\t%1,%0\n\tjle\t%a\n",	/* stmt: LEI(reg,mrc) */
/* 209 */	"\tcmpl\t%1,%0\n\tjl\t%a\n",	/* stmt: LTI(reg,mrc) */
/* 210 */	"\tcmpl\t%1,%0\n\tjne\t%a\n",	/* stmt: NEI(reg,mrc) */
/* 211 */	"\tcmpl\t%1,%0\n\tjae\t%a\n",	/* stmt: GEU(reg,mrc) */
/* 212 */	"\tcmpl\t%1,%0\n\tja \t%a\n",	/* stmt: GTU(reg,mrc) */
/* 213 */	"\tcmpl\t%1,%0\n\tjbe\t%a\n",	/* stmt: LEU(reg,mrc) */
/* 214 */	"\tcmpl\t%1,%0\n\tjb \t%a\n",	/* stmt: LTU(reg,mrc) */
/* 215 */	"l\t%0",	/* cmpf: INDIRD(addr) */
/* 216 */	"s\t%0",	/* cmpf: INDIRF(addr) */
/* 217 */	"s\t%0",	/* cmpf: CVFD(INDIRF(addr)) */
/* 218 */	"p",	/* cmpf: freg */
/* 219 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tje\t%a\n",	/* stmt: EQD(cmpf,freg) */
/* 220 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjbe\t%a\n",	/* stmt: GED(cmpf,freg) */
/* 221 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjb\t%a\n",	/* stmt: GTD(cmpf,freg) */
/* 222 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjae\t%a\n",	/* stmt: LED(cmpf,freg) */
/* 223 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tja\t%a\n",	/* stmt: LTD(cmpf,freg) */
/* 224 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjne\t%a\n",	/* stmt: NED(cmpf,freg) */
/* 225 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tje\t%a\n",	/* stmt: EQF(cmpf,freg) */
/* 226 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjbe\t%a\n",	/* stmt: GEF(cmpf,freg) */
/* 227 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjb\t%a\n",	/* stmt: GTF(cmpf,freg) */
/* 228 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjae\t%a\n",	/* stmt: LEF(cmpf,freg) */
/* 229 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tja\t%a\n",	/* stmt: LTF(cmpf,freg) */
/* 230 */	"\tfcomp%0\n\tfstsw %%ax\n\tsahf\n\tjne\t%a\n",	/* stmt: NEF(cmpf,freg) */
/* 231 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n",	/* reg: CALLI(addrj) */
/* 232 */	"\tcall\t%0\n",	/* reg: CALLI(addrj) */
/* 233 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n",	/* stmt: CALLV(addrj) */
/* 234 */	"\tcall\t%0\n",	/* stmt: CALLV(addrj) */
/* 235 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n",	/* freg: CALLF(addrj) */
/* 236 */	"\tcall\t%0\n",	/* freg: CALLF(addrj) */
/* 237 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n\tfstp\t%%st(0)\n",	/* stmt: CALLF(addrj) */
/* 238 */	"\tcall\t%0\n\tfstp\t%%st(0)\n",	/* stmt: CALLF(addrj) */
/* 239 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n",	/* freg: CALLD(addrj) */
/* 240 */	"\tcall\t%0\n",	/* freg: CALLD(addrj) */
/* 241 */	"\tcall\t%0\n\taddl\t$%a,%%esp\n\tfstp\t%%st(0)\n",	/* stmt: CALLD(addrj) */
/* 242 */	"\tcall\t%0\n\tfstp\t%%st(0)\n",	/* stmt: CALLD(addrj) */
/* 243 */	"# ret\n",	/* stmt: RETI(reg) */
/* 244 */	"# retf\n",	/* stmt: RETF(freg) */
/* 245 */	"# retd\n",	/* stmt: RETD(freg) */
};

static char _isinstruction[] = {
/* 0 */	0,
/* 1 */	1,	/* # read register\n */
/* 2 */	1,	/* # read register\n */
/* 3 */	1,	/* # read register\n */
/* 4 */	1,	/* # read register\n */
/* 5 */	1,	/* # read register\n */
/* 6 */	1,	/* # read register\n */
/* 7 */	1,	/* # write register\n */
/* 8 */	1,	/* # write register\n */
/* 9 */	1,	/* # write register\n */
/* 10 */	1,	/* # write register\n */
/* 11 */	1,	/* # write register\n */
/* 12 */	1,	/* # write register\n */
/* 13 */	0,	/* $%a */
/* 14 */	0,	/* $%a */
/* 15 */	0,	/* $%a */
/* 16 */	0,	/* $%a */
/* 17 */	0,	/* $%a */
/* 18 */	0,	/*  */
/* 19 */	0,	/*  */
/* 20 */	0,	/* %0 */
/* 21 */	0,	/* %0 */
/* 22 */	0,	/* %0 */
/* 23 */	0,	/* %0 */
/* 24 */	0,	/* %a */
/* 25 */	0,	/* %a */
/* 26 */	0,	/* %a */
/* 27 */	0,	/* %a */
/* 28 */	0,	/* %a */
/* 29 */	0,	/* %a */
/* 30 */	0,	/* %a */
/* 31 */	0,	/* (%0) */
/* 32 */	0,	/* %1(%0) */
/* 33 */	0,	/* %1(%0) */
/* 34 */	0,	/* %1(%0) */
/* 35 */	0,	/* %a(%%ebp) */
/* 36 */	0,	/* %a(%%ebp) */
/* 37 */	0,	/* 1 */
/* 38 */	0,	/* 1 */
/* 39 */	0,	/* 2 */
/* 40 */	0,	/* 2 */
/* 41 */	0,	/* 4 */
/* 42 */	0,	/* 4 */
/* 43 */	0,	/* 8 */
/* 44 */	0,	/* 8 */
/* 45 */	0,	/* %0 */
/* 46 */	0,	/* %0,%1 */
/* 47 */	0,	/* %0,%1 */
/* 48 */	0,	/* %0 */
/* 49 */	0,	/* %0 */
/* 50 */	0,	/* %1(,%0) */
/* 51 */	0,	/* %1(%0) */
/* 52 */	0,	/* (%1,%0) */
/* 53 */	0,	/* %1(,%0) */
/* 54 */	0,	/* %1(%0) */
/* 55 */	0,	/* (%1,%0) */
/* 56 */	0,	/* %1(,%0) */
/* 57 */	0,	/* %1(%0) */
/* 58 */	0,	/* (%1,%0) */
/* 59 */	0,	/* (,%0) */
/* 60 */	0,	/* %0 */
/* 61 */	0,	/* %0 */
/* 62 */	0,	/* %0 */
/* 63 */	0,	/* %0 */
/* 64 */	0,	/* $%a */
/* 65 */	0,	/* %%cl */
/* 66 */	0,	/* %0 */
/* 67 */	0,	/* %0 */
/* 68 */	0,	/* %0 */
/* 69 */	0,	/* %0 */
/* 70 */	0,	/* %0 */
/* 71 */	0,	/* %0 */
/* 72 */	0,	/* %0 */
/* 73 */	0,	/* %0 */
/* 74 */	0,	/* %0 */
/* 75 */	0,	/* %0 */
/* 76 */	0,	/* %0 */
/* 77 */	0,	/* %0 */
/* 78 */	1,	/* \tleal\t%0,%c\n */
/* 79 */	1,	/* \tmovl\t%0,%c\n */
/* 80 */	1,	/* \tmovb\t%0,%c\n */
/* 81 */	1,	/* \tmovw\t%0,%c\n */
/* 82 */	1,	/* \tmovl\t%0,%c\n */
/* 83 */	1,	/* \tmovb\t%0,%c\n */
/* 84 */	1,	/* \tmovl\t%0,%c\n */
/* 85 */	1,	/* \tmovl\t%0,%c\n */
/* 86 */	1,	/* \tmovw\t%0,%c\n */
/* 87 */	1,	/* \tmovl\t%0,%c\n */
/* 88 */	1,	/* ?\tmovl\t%0,%c\n\taddl\t%1,%c\n */
/* 89 */	1,	/* ?\tmovl\t%0,%c\n\taddl\t%1,%c\n */
/* 90 */	1,	/* ?\tmovl\t%0,%c\n\taddl\t%1,%c\n */
/* 91 */	1,	/* ?\tmovl\t%0,%c\n\tsubl\t%1,%c\n */
/* 92 */	1,	/* ?\tmovl\t%0,%c\n\tsubl\t%1,%c\n */
/* 93 */	1,	/* ?\tmovl\t%0,%c\n\tsubl\t%1,%c\n */
/* 94 */	1,	/* ?\tmovl\t%0,%c\n\tandl\t%1,%c\n */
/* 95 */	1,	/* ?\tmovl\t%0,%c\n\torl\t%1,%c\n */
/* 96 */	1,	/* ?\tmovl\t%0,%c\n\txorl\t%1,%c\n */
/* 97 */	1,	/* ?\tmovl\t%0,%c\n\tsall\t%1,%c\n */
/* 98 */	1,	/* ?\tmovl\t%0,%c\n\tshll\t%1,%c\n */
/* 99 */	1,	/* ?\tmovl\t%0,%c\n\tsarl\t%1,%c\n */
/* 100 */	1,	/* ?\tmovl\t%0,%c\n\tshrl\t%1,%c\n */
/* 101 */	1,	/* ?\tmovl\t%0,%c\n\tnotl\t%c\n */
/* 102 */	1,	/* ?\tmovl\t%0,%c\n\tnegl\t%c\n */
/* 103 */	1,	/* \tincl\t%1\n */
/* 104 */	1,	/* \tincl\t%1\n */
/* 105 */	1,	/* \tincl\t%1\n */
/* 106 */	1,	/* \tdecl\t%1\n */
/* 107 */	1,	/* \tdecl\t%1\n */
/* 108 */	1,	/* \tdecl\t%1\n */
/* 109 */	1,	/* \taddl\t%2,%1\n */
/* 110 */	1,	/* \taddl\t%2,%1\n */
/* 111 */	1,	/* \tsubl\t%2,%1\n */
/* 112 */	1,	/* \tsubl\t%2,%1\n */
/* 113 */	1,	/* \tandl\t%2,%1\n */
/* 114 */	1,	/* \torl\t%2,%1\n */
/* 115 */	1,	/* \txorl\t%2,%1\n */
/* 116 */	1,	/* \tnotl\t%1\n */
/* 117 */	1,	/* \tnegl\t%1\n */
/* 118 */	1,	/* \tsall\t%2,%1\n */
/* 119 */	1,	/* \tshll\t%2,%1\n */
/* 120 */	1,	/* \tsarl\t%2,%1\n */
/* 121 */	1,	/* \tshrl\t%2,%1\n */
/* 122 */	1,	/* ?\tmovl\t%0,%c\n\timull\t%1,%c\n */
/* 123 */	1,	/* \timul\t%0,%1,%c\n */
/* 124 */	1,	/* \tmull\t%1\n */
/* 125 */	1,	/* \txorl\t%%edx,%%edx\n\tdivl\t%1\n */
/* 126 */	1,	/* \txorl\t%%edx,%%edx\n\tdivl\t%1\n */
/* 127 */	1,	/* \tcdq\n\tidivl\t%1\n */
/* 128 */	1,	/* \tcdq\n\tidivl\t%1\n */
/* 129 */	1,	/* \tmovl\t%0,%c\n */
/* 130 */	1,	/* \tmovl\t%0,%c\n */
/* 131 */	1,	/* \tmovl\t%0,%c\n */
/* 132 */	1,	/* \tmovl\t%0,%c\n */
/* 133 */	1,	/* \tmovsbl\t%0,%c\n */
/* 134 */	1,	/* \tmovzbl\t%0,%c\n */
/* 135 */	1,	/* \tmovswl\t%0,%c\n */
/* 136 */	1,	/* \tmovzwl\t%0,%c\n */
/* 137 */	1,	/* # extend\n */
/* 138 */	1,	/* # extend\n */
/* 139 */	1,	/* # extend\n */
/* 140 */	1,	/* # extend\n */
/* 141 */	1,	/* # truncate\n */
/* 142 */	1,	/* # truncate\n */
/* 143 */	1,	/* # truncate\n */
/* 144 */	1,	/* # truncate\n */
/* 145 */	0,	/* %0 */
/* 146 */	0,	/* %0 */
/* 147 */	0,	/* $%a */
/* 148 */	1,	/* \tmovb\t%1,%0\n */
/* 149 */	1,	/* \tmovl\t%1,%0\n */
/* 150 */	1,	/* \tmovl\t%1,%0\n */
/* 151 */	1,	/* \tmovw\t%1,%0\n */
/* 152 */	1,	/* \tmovl\t$%a,%%ecx\n\trep\n\tmovsb\n */
/* 153 */	1,	/* \tpushl\t%0\n */
/* 154 */	1,	/* \tpushl\t%0\n */
/* 155 */	1,	/* \tsubl\t$%a,%%esp\n\tmovl\t%%esp,%%edi\n\tmovl\t$%a,%%ecx\n\trep\n\tmovsb\n */
/* 156 */	0,	/* l\t%0 */
/* 157 */	0,	/* s\t%0 */
/* 158 */	0,	/* s\t%0 */
/* 159 */	1,	/* \tfld%0\n */
/* 160 */	1,	/* \tfstpl\t%0\n */
/* 161 */	1,	/* \tfstps\t%0\n */
/* 162 */	1,	/* \tfstps\t%0\n */
/* 163 */	1,	/* \tsubl\t$8,%%esp\n\tfstpl\t(%%esp)\n */
/* 164 */	1,	/* \tsubl\t$4,%%esp\n\tfstps\t(%%esp)\n */
/* 165 */	1,	/* \tfchs\n */
/* 166 */	1,	/* \tfchs\n */
/* 167 */	0,	/* %0 */
/* 168 */	0,	/* p\t%%st,%%st(1) */
/* 169 */	1,	/* \tfadd%1\n */
/* 170 */	1,	/* \tfadd%1\n */
/* 171 */	1,	/* \tfdiv%1\n */
/* 172 */	1,	/* \tfdivrp\t%%st,%%st(1)\n */
/* 173 */	1,	/* \tfdiv%1\n */
/* 174 */	1,	/* \tfdivrp\t%%st,%%st(1)\n */
/* 175 */	1,	/* \tfmul%1\n */
/* 176 */	1,	/* \tfmul%1\n */
/* 177 */	1,	/* \tfsub%1\n */
/* 178 */	1,	/* \tfsubrp\t%%st,%%st(1)\n */
/* 179 */	1,	/* \tfsub%1\n */
/* 180 */	1,	/* \tfsubrp\t%%st,%%st(1)\n */
/* 181 */	1,	/* # CVFD\n */
/* 182 */	1,	/* \tsub\t$4,%%esp ; fstps (%%esp) ; flds (%%esp) ; addl $4,%%esp\n */
/* 183 */	1,	/* \tfistpl\t%0\n */
/* 184 */	1,	/* \tsubl\t$4,%%esp\n\tfistpl\t0(%%esp)\n\tpopl\t%c\n */
/* 185 */	1,	/* \tfildl\t%0\n */
/* 186 */	1,	/* \tpushl\t%0\n\tfildl\t(%%esp)\n\taddl\t$4,%%esp\n */
/* 187 */	0,	/* %a */
/* 188 */	0,	/* *%0 */
/* 189 */	0,	/* *%0 */
/* 190 */	0,	/* %a */
/* 191 */	0,	/* *%0 */
/* 192 */	0,	/* *%0 */
/* 193 */	1,	/* %a:\n */
/* 194 */	1,	/* \tjmp\t%0\n */
/* 195 */	1,	/* \tcmpl\t%1,%0\n\tje\t%a\n */
/* 196 */	1,	/* \tcmpl\t%1,%0\n\tjge\t%a\n */
/* 197 */	1,	/* \tcmpl\t%1,%0\n\tjg\t%a\n */
/* 198 */	1,	/* \tcmpl\t%1,%0\n\tjle\t%a\n */
/* 199 */	1,	/* \tcmpl\t%1,%0\n\tjl\t%a\n */
/* 200 */	1,	/* \tcmpl\t%1,%0\n\tjne\t%a\n */
/* 201 */	1,	/* \tcmpl\t%1,%0\n\tjae\t%a\n */
/* 202 */	1,	/* \tcmpl\t%1,%0\n\tja \t%a\n */
/* 203 */	1,	/* \tcmpl\t%1,%0\n\tjbe\t%a\n */
/* 204 */	1,	/* \tcmpl\t%1,%0\n\tjb \t%a\n */
/* 205 */	1,	/* \tcmpl\t%1,%0\n\tje\t%a\n */
/* 206 */	1,	/* \tcmpl\t%1,%0\n\tjge\t%a\n */
/* 207 */	1,	/* \tcmpl\t%1,%0\n\tjg\t%a\n */
/* 208 */	1,	/* \tcmpl\t%1,%0\n\tjle\t%a\n */
/* 209 */	1,	/* \tcmpl\t%1,%0\n\tjl\t%a\n */
/* 210 */	1,	/* \tcmpl\t%1,%0\n\tjne\t%a\n */
/* 211 */	1,	/* \tcmpl\t%1,%0\n\tjae\t%a\n */
/* 212 */	1,	/* \tcmpl\t%1,%0\n\tja \t%a\n */
/* 213 */	1,	/* \tcmpl\t%1,%0\n\tjbe\t%a\n */
/* 214 */	1,	/* \tcmpl\t%1,%0\n\tjb \t%a\n */
/* 215 */	0,	/* l\t%0 */
/* 216 */	0,	/* s\t%0 */
/* 217 */	0,	/* s\t%0 */
/* 218 */	0,	/* p */
/* 219 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tje\t%a\n */
/* 220 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjbe\t%a\n */
/* 221 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjb\t%a\n */
/* 222 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjae\t%a\n */
/* 223 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tja\t%a\n */
/* 224 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjne\t%a\n */
/* 225 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tje\t%a\n */
/* 226 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjbe\t%a\n */
/* 227 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjb\t%a\n */
/* 228 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjae\t%a\n */
/* 229 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tja\t%a\n */
/* 230 */	1,	/* \tfcomp%0 ; fstsw %%ax ; sahf\n\tjne\t%a\n */
/* 231 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n */
/* 232 */	1,	/* \tcall\t%0\n */
/* 233 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n */
/* 234 */	1,	/* \tcall\t%0\n */
/* 235 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n */
/* 236 */	1,	/* \tcall\t%0\n */
/* 237 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n\tfstp\t%%st(0)\n */
/* 238 */	1,	/* \tcall\t%0\n\tfstp\t%%st(0)\n */
/* 239 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n */
/* 240 */	1,	/* \tcall\t%0\n */
/* 241 */	1,	/* \tcall\t%0\n\taddl\t$%a,%%esp\n\tfstp\t%%st(0)\n */
/* 242 */	1,	/* \tcall\t%0\n\tfstp\t%%st(0)\n */
/* 243 */	1,	/* # ret\n */
/* 244 */	1,	/* # retf\n */
/* 245 */	1,	/* # retd\n */
};

static char *_string[] = {
/* 0 */	0,
/* 1 */	"reg: INDIRC(VREGP)",
/* 2 */	"reg: INDIRI(VREGP)",
/* 3 */	"reg: INDIRP(VREGP)",
/* 4 */	"reg: INDIRS(VREGP)",
/* 5 */	"freg: INDIRD(VREGP)",
/* 6 */	"freg: INDIRF(VREGP)",
/* 7 */	"stmt: ASGNC(VREGP,reg)",
/* 8 */	"stmt: ASGNI(VREGP,reg)",
/* 9 */	"stmt: ASGNP(VREGP,reg)",
/* 10 */	"stmt: ASGNS(VREGP,reg)",
/* 11 */	"stmt: ASGND(VREGP,freg)",
/* 12 */	"stmt: ASGNF(VREGP,freg)",
/* 13 */	"con: CNSTC",
/* 14 */	"con: CNSTI",
/* 15 */	"con: CNSTP",
/* 16 */	"con: CNSTS",
/* 17 */	"con: CNSTU",
/* 18 */	"stmt: reg",
/* 19 */	"stmt: freg",
/* 20 */	"reg: CVIU(reg)",
/* 21 */	"reg: CVPU(reg)",
/* 22 */	"reg: CVUI(reg)",
/* 23 */	"reg: CVUP(reg)",
/* 24 */	"acon: ADDRGP",
/* 25 */	"acon: CNSTC",
/* 26 */	"acon: CNSTI",
/* 27 */	"acon: CNSTP",
/* 28 */	"acon: CNSTS",
/* 29 */	"acon: CNSTU",
/* 30 */	"baseaddr: ADDRGP",
/* 31 */	"base: reg",
/* 32 */	"base: ADDI(reg,acon)",
/* 33 */	"base: ADDP(reg,acon)",
/* 34 */	"base: ADDU(reg,acon)",
/* 35 */	"base: ADDRFP",
/* 36 */	"base: ADDRLP",
/* 37 */	"con1: CNSTI",
/* 38 */	"con1: CNSTU",
/* 39 */	"icon: CNSTI",
/* 40 */	"icon: CNSTU",
/* 41 */	"icon: CNSTI",
/* 42 */	"icon: CNSTU",
/* 43 */	"icon: CNSTI",
/* 44 */	"icon: CNSTU",
/* 45 */	"index: reg",
/* 46 */	"index: LSHI(reg,icon)",
/* 47 */	"index: LSHU(reg,icon)",
/* 48 */	"addr: base",
/* 49 */	"addr: baseaddr",
/* 50 */	"addr: ADDI(index,baseaddr)",
/* 51 */	"addr: ADDI(reg,baseaddr)",
/* 52 */	"addr: ADDI(index,reg)",
/* 53 */	"addr: ADDP(index,baseaddr)",
/* 54 */	"addr: ADDP(reg,baseaddr)",
/* 55 */	"addr: ADDP(index,reg)",
/* 56 */	"addr: ADDU(index,baseaddr)",
/* 57 */	"addr: ADDU(reg,baseaddr)",
/* 58 */	"addr: ADDU(index,reg)",
/* 59 */	"addr: index",
/* 60 */	"memb: INDIRC(addr)",
/* 61 */	"memw: INDIRS(addr)",
/* 62 */	"mem: INDIRI(addr)",
/* 63 */	"mem: INDIRP(addr)",
/* 64 */	"rc5: CNSTI",
/* 65 */	"rc5: reg",
/* 66 */	"rc: reg",
/* 67 */	"rc: con",
/* 68 */	"mr: reg",
/* 69 */	"mr: mem",
/* 70 */	"mrb: reg",
/* 71 */	"mrb: memb",
/* 72 */	"mrw: reg",
/* 73 */	"mrw: memw",
/* 74 */	"mrc: mem",
/* 75 */	"mrc: memb",
/* 76 */	"mrc: memw",
/* 77 */	"mrc: rc",
/* 78 */	"reg: addr",
/* 79 */	"reg: mr",
/* 80 */	"reg: mrb",
/* 81 */	"reg: mrw",
/* 82 */	"reg: con",
/* 83 */	"reg: LOADC(reg)",
/* 84 */	"reg: LOADI(reg)",
/* 85 */	"reg: LOADP(reg)",
/* 86 */	"reg: LOADS(reg)",
/* 87 */	"reg: LOADU(reg)",
/* 88 */	"reg: ADDI(reg,mrc)",
/* 89 */	"reg: ADDP(reg,mrc)",
/* 90 */	"reg: ADDU(reg,mrc)",
/* 91 */	"reg: SUBI(reg,mrc)",
/* 92 */	"reg: SUBP(reg,mrc)",
/* 93 */	"reg: SUBU(reg,mrc)",
/* 94 */	"reg: BANDU(reg,mrc)",
/* 95 */	"reg: BORU(reg,mrc)",
/* 96 */	"reg: BXORU(reg,mrc)",
/* 97 */	"reg: LSHI(reg,rc5)",
/* 98 */	"reg: LSHU(reg,rc5)",
/* 99 */	"reg: RSHI(reg,rc5)",
/* 100 */	"reg: RSHU(reg,rc5)",
/* 101 */	"reg: BCOMU(reg)",
/* 102 */	"reg: NEGI(reg)",
/* 103 */	"stmt: ASGNI(addr,ADDI(mem,con1))",
/* 104 */	"stmt: ASGNI(addr,ADDU(mem,con1))",
/* 105 */	"stmt: ASGNP(addr,ADDP(mem,con1))",
/* 106 */	"stmt: ASGNI(addr,SUBI(mem,con1))",
/* 107 */	"stmt: ASGNI(addr,SUBU(mem,con1))",
/* 108 */	"stmt: ASGNP(addr,SUBP(mem,con1))",
/* 109 */	"stmt: ASGNI(addr,ADDI(mem,rc))",
/* 110 */	"stmt: ASGNI(addr,ADDU(mem,rc))",
/* 111 */	"stmt: ASGNI(addr,SUBI(mem,rc))",
/* 112 */	"stmt: ASGNI(addr,SUBU(mem,rc))",
/* 113 */	"stmt: ASGNI(addr,BANDU(mem,rc))",
/* 114 */	"stmt: ASGNI(addr,BORU(mem,rc))",
/* 115 */	"stmt: ASGNI(addr,BXORU(mem,rc))",
/* 116 */	"stmt: ASGNI(addr,BCOMU(mem))",
/* 117 */	"stmt: ASGNI(addr,NEGI(mem))",
/* 118 */	"stmt: ASGNI(addr,LSHI(mem,rc5))",
/* 119 */	"stmt: ASGNI(addr,LSHU(mem,rc5))",
/* 120 */	"stmt: ASGNI(addr,RSHI(mem,rc5))",
/* 121 */	"stmt: ASGNI(addr,RSHU(mem,rc5))",
/* 122 */	"reg: MULI(reg,mrc)",
/* 123 */	"reg: MULI(con,mr)",
/* 124 */	"reg: MULU(reg,mr)",
/* 125 */	"reg: DIVU(reg,reg)",
/* 126 */	"reg: MODU(reg,reg)",
/* 127 */	"reg: DIVI(reg,reg)",
/* 128 */	"reg: MODI(reg,reg)",
/* 129 */	"reg: CVIU(reg)",
/* 130 */	"reg: CVPU(reg)",
/* 131 */	"reg: CVUI(reg)",
/* 132 */	"reg: CVUP(reg)",
/* 133 */	"reg: CVCI(INDIRC(addr))",
/* 134 */	"reg: CVCU(INDIRC(addr))",
/* 135 */	"reg: CVSI(INDIRS(addr))",
/* 136 */	"reg: CVSU(INDIRS(addr))",
/* 137 */	"reg: CVCI(reg)",
/* 138 */	"reg: CVCU(reg)",
/* 139 */	"reg: CVSI(reg)",
/* 140 */	"reg: CVSU(reg)",
/* 141 */	"reg: CVIC(reg)",
/* 142 */	"reg: CVIS(reg)",
/* 143 */	"reg: CVUC(reg)",
/* 144 */	"reg: CVUS(reg)",
/* 145 */	"mrca: mem",
/* 146 */	"mrca: rc",
/* 147 */	"mrca: ADDRGP",
/* 148 */	"stmt: ASGNC(addr,rc)",
/* 149 */	"stmt: ASGNI(addr,rc)",
/* 150 */	"stmt: ASGNP(addr,rc)",
/* 151 */	"stmt: ASGNS(addr,rc)",
/* 152 */	"stmt: ASGNB(reg,INDIRB(reg))",
/* 153 */	"stmt: ARGI(mrca)",
/* 154 */	"stmt: ARGP(mrca)",
/* 155 */	"stmt: ARGB(INDIRB(reg))",
/* 156 */	"memf: INDIRD(addr)",
/* 157 */	"memf: INDIRF(addr)",
/* 158 */	"memf: CVFD(INDIRF(addr))",
/* 159 */	"freg: memf",
/* 160 */	"stmt: ASGND(addr,freg)",
/* 161 */	"stmt: ASGNF(addr,freg)",
/* 162 */	"stmt: ASGNF(addr,CVDF(freg))",
/* 163 */	"stmt: ARGD(freg)",
/* 164 */	"stmt: ARGF(freg)",
/* 165 */	"freg: NEGD(freg)",
/* 166 */	"freg: NEGF(freg)",
/* 167 */	"flt: memf",
/* 168 */	"flt: freg",
/* 169 */	"freg: ADDD(freg,flt)",
/* 170 */	"freg: ADDF(freg,flt)",
/* 171 */	"freg: DIVD(freg,memf)",
/* 172 */	"freg: DIVD(freg,freg)",
/* 173 */	"freg: DIVF(freg,memf)",
/* 174 */	"freg: DIVF(freg,freg)",
/* 175 */	"freg: MULD(freg,flt)",
/* 176 */	"freg: MULF(freg,flt)",
/* 177 */	"freg: SUBD(freg,memf)",
/* 178 */	"freg: SUBD(freg,freg)",
/* 179 */	"freg: SUBF(freg,memf)",
/* 180 */	"freg: SUBF(freg,freg)",
/* 181 */	"freg: CVFD(freg)",
/* 182 */	"freg: CVDF(freg)",
/* 183 */	"stmt: ASGNI(addr,CVDI(freg))",
/* 184 */	"reg: CVDI(freg)",
/* 185 */	"freg: CVID(INDIRI(addr))",
/* 186 */	"freg: CVID(reg)",
/* 187 */	"addrj: ADDRGP",
/* 188 */	"addrj: reg",
/* 189 */	"addrj: mem",
/* 190 */	"addrjmp: ADDRGP",
/* 191 */	"addrjmp: reg",
/* 192 */	"addrjmp: mem",
/* 193 */	"stmt: LABELV",
/* 194 */	"stmt: JUMPV(addrjmp)",
/* 195 */	"stmt: EQI(mem,rc)",
/* 196 */	"stmt: GEI(mem,rc)",
/* 197 */	"stmt: GTI(mem,rc)",
/* 198 */	"stmt: LEI(mem,rc)",
/* 199 */	"stmt: LTI(mem,rc)",
/* 200 */	"stmt: NEI(mem,rc)",
/* 201 */	"stmt: GEU(mem,rc)",
/* 202 */	"stmt: GTU(mem,rc)",
/* 203 */	"stmt: LEU(mem,rc)",
/* 204 */	"stmt: LTU(mem,rc)",
/* 205 */	"stmt: EQI(reg,mrc)",
/* 206 */	"stmt: GEI(reg,mrc)",
/* 207 */	"stmt: GTI(reg,mrc)",
/* 208 */	"stmt: LEI(reg,mrc)",
/* 209 */	"stmt: LTI(reg,mrc)",
/* 210 */	"stmt: NEI(reg,mrc)",
/* 211 */	"stmt: GEU(reg,mrc)",
/* 212 */	"stmt: GTU(reg,mrc)",
/* 213 */	"stmt: LEU(reg,mrc)",
/* 214 */	"stmt: LTU(reg,mrc)",
/* 215 */	"cmpf: INDIRD(addr)",
/* 216 */	"cmpf: INDIRF(addr)",
/* 217 */	"cmpf: CVFD(INDIRF(addr))",
/* 218 */	"cmpf: freg",
/* 219 */	"stmt: EQD(cmpf,freg)",
/* 220 */	"stmt: GED(cmpf,freg)",
/* 221 */	"stmt: GTD(cmpf,freg)",
/* 222 */	"stmt: LED(cmpf,freg)",
/* 223 */	"stmt: LTD(cmpf,freg)",
/* 224 */	"stmt: NED(cmpf,freg)",
/* 225 */	"stmt: EQF(cmpf,freg)",
/* 226 */	"stmt: GEF(cmpf,freg)",
/* 227 */	"stmt: GTF(cmpf,freg)",
/* 228 */	"stmt: LEF(cmpf,freg)",
/* 229 */	"stmt: LTF(cmpf,freg)",
/* 230 */	"stmt: NEF(cmpf,freg)",
/* 231 */	"reg: CALLI(addrj)",
/* 232 */	"reg: CALLI(addrj)",
/* 233 */	"stmt: CALLV(addrj)",
/* 234 */	"stmt: CALLV(addrj)",
/* 235 */	"freg: CALLF(addrj)",
/* 236 */	"freg: CALLF(addrj)",
/* 237 */	"stmt: CALLF(addrj)",
/* 238 */	"stmt: CALLF(addrj)",
/* 239 */	"freg: CALLD(addrj)",
/* 240 */	"freg: CALLD(addrj)",
/* 241 */	"stmt: CALLD(addrj)",
/* 242 */	"stmt: CALLD(addrj)",
/* 243 */	"stmt: RETI(reg)",
/* 244 */	"stmt: RETF(freg)",
/* 245 */	"stmt: RETD(freg)",
};

static short _decode_stmt[] = {
	0,
	7,
	8,
	9,
	10,
	11,
	12,
	18,
	19,
	103,
	104,
	105,
	106,
	107,
	108,
	109,
	110,
	111,
	112,
	113,
	114,
	115,
	116,
	117,
	118,
	119,
	120,
	121,
	148,
	149,
	150,
	151,
	152,
	153,
	154,
	155,
	160,
	161,
	162,
	163,
	164,
	183,
	193,
	194,
	195,
	196,
	197,
	198,
	199,
	200,
	201,
	202,
	203,
	204,
	205,
	206,
	207,
	208,
	209,
	210,
	211,
	212,
	213,
	214,
	219,
	220,
	221,
	222,
	223,
	224,
	225,
	226,
	227,
	228,
	229,
	230,
	233,
	234,
	237,
	238,
	241,
	242,
	243,
	244,
	245,
};

static short _decode_reg[] = {
	0,
	1,
	2,
	3,
	4,
	20,
	21,
	22,
	23,
	78,
	79,
	80,
	81,
	82,
	83,
	84,
	85,
	86,
	87,
	88,
	89,
	90,
	91,
	92,
	93,
	94,
	95,
	96,
	97,
	98,
	99,
	100,
	101,
	102,
	122,
	123,
	124,
	125,
	126,
	127,
	128,
	129,
	130,
	131,
	132,
	133,
	134,
	135,
	136,
	137,
	138,
	139,
	140,
	141,
	142,
	143,
	144,
	184,
	231,
	232,
};

static short _decode_freg[] = {
	0,
	5,
	6,
	159,
	165,
	166,
	169,
	170,
	171,
	172,
	173,
	174,
	175,
	176,
	177,
	178,
	179,
	180,
	181,
	182,
	185,
	186,
	235,
	236,
	239,
	240,
};

static short _decode_con[] = {
	0,
	13,
	14,
	15,
	16,
	17,
};

static short _decode_acon[] = {
	0,
	24,
	25,
	26,
	27,
	28,
	29,
};

static short _decode_baseaddr[] = {
	0,
	30,
};

static short _decode_base[] = {
	0,
	31,
	32,
	33,
	34,
	35,
	36,
};

static short _decode_con1[] = {
	0,
	37,
	38,
};

static short _decode_icon[] = {
	0,
	39,
	40,
	41,
	42,
	43,
	44,
};

static short _decode_index[] = {
	0,
	45,
	46,
	47,
};

static short _decode_addr[] = {
	0,
	48,
	49,
	50,
	51,
	52,
	53,
	54,
	55,
	56,
	57,
	58,
	59,
};

static short _decode_memb[] = {
	0,
	60,
};

static short _decode_memw[] = {
	0,
	61,
};

static short _decode_mem[] = {
	0,
	62,
	63,
};

static short _decode_rc5[] = {
	0,
	64,
	65,
};

static short _decode_rc[] = {
	0,
	66,
	67,
};

static short _decode_mr[] = {
	0,
	68,
	69,
};

static short _decode_mrb[] = {
	0,
	70,
	71,
};

static short _decode_mrw[] = {
	0,
	72,
	73,
};

static short _decode_mrc[] = {
	0,
	74,
	75,
	76,
	77,
};

static short _decode_mrca[] = {
	0,
	145,
	146,
	147,
};

static short _decode_memf[] = {
	0,
	156,
	157,
	158,
};

static short _decode_flt[] = {
	0,
	167,
	168,
};

static short _decode_addrj[] = {
	0,
	187,
	188,
	189,
};

static short _decode_addrjmp[] = {
	0,
	190,
	191,
	192,
};

static short _decode_cmpf[] = {
	0,
	215,
	216,
	217,
	218,
};

static short * DecodeTables[] = {
_decode_stmt,
_decode_reg,
_decode_freg,
_decode_con,
_decode_acon,
_decode_baseaddr,
_decode_base,
_decode_con1,
_decode_icon,
_decode_index,
_decode_addr,
_decode_memb,
_decode_memw,
_decode_mem,
_decode_rc5,
_decode_rc,
_decode_mr,
_decode_mrb,
_decode_mrw,
_decode_mrc,
_decode_mrca,
_decode_memf,
_decode_flt,
_decode_addrj,
_decode_addrjmp,
_decode_cmpf
};


static int _rule(void *state,int goalnt)
{
	unsigned char *p;
	struct _state * State = (struct _state *)state;
	short *ps;

	if (goalnt < 1 || goalnt > 26)
		fatal("_rule", "Bad goal nonterminal %d\n", goalnt);
	if (!state)
		return 0;
	goalnt--;
	p = &State->rule._stmt;
	ps = DecodeTables[goalnt];
	return ps[p[goalnt]];
}

static void _stdcall _closure_reg ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_freg ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_con ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_baseaddr ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_base ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_index ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_addr ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_memb ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_memw ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_mem ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_rc ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_mr ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_mrb ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_mrw ARGS((NODEPTR_TYPE, int));
static void _stdcall _closure_memf ARGS((NODEPTR_TYPE, int));

static void _stdcall _closure_reg(NODEPTR_TYPE a,register int c) {
	struct _state *p = STATE_LABEL(a);
	register short *cost = p->cost;
	if (c + 2 < cost[_addrjmp_NT]) {
		cost[_addrjmp_NT] = c + 2;
		p->rule._addrjmp = 2;
	}
	if (c + 2 < cost[_addrj_NT]) {
		cost[_addrj_NT] = c + 2;
		p->rule._addrj = 2;
	}
	if (c < cost[_mrw_NT]) {
		cost[_mrw_NT] = c;
		p->rule._mrw = 1;
		_closure_mrw(a, c);
	}
	if (c < cost[_mrb_NT]) {
		cost[_mrb_NT] = c;
		p->rule._mrb = 1;
		_closure_mrb(a, c);
	}
	if (c < cost[_mr_NT]) {
		cost[_mr_NT] = c;
		p->rule._mr = 1;
		_closure_mr(a, c);
	}
	if (c < cost[_rc_NT]) {
		cost[_rc_NT] = c;
		p->rule._rc = 1;
		_closure_rc(a, c);
	}
	if (c < cost[_rc5_NT]) {
		cost[_rc5_NT] = c;
		p->rule._rc5 = 2;
	}
	if (c < cost[_index_NT]) {
		cost[_index_NT] = c;
		p->rule._index = 1;
		_closure_index(a, c);
	}
	if (c < cost[_base_NT]) {
		cost[_base_NT] = c;
		p->rule._base = 1;
		_closure_base(a, c);
	}
	if (c < cost[_stmt_NT]) {
		cost[_stmt_NT] = c;
		p->rule._stmt = 7;
	}
}

static void _stdcall _closure_freg(NODEPTR_TYPE a, int c) 
{
	struct _state *p = STATE_LABEL(a);
	register short *cost = p->cost;

	if (c < cost[_cmpf_NT]) {
		cost[_cmpf_NT] = c;
		p->rule._cmpf = 4;
	}
	if (c < cost[_flt_NT]) {
		cost[_flt_NT] = c;
		p->rule._flt = 2;
	}
	if (c < cost[_stmt_NT]) {
		cost[_stmt_NT] = c;
		p->rule._stmt = 8;
	}
}

static void _stdcall _closure_con(NODEPTR_TYPE a,int c)
{
	struct _state *p = STATE_LABEL(a);
	register short *cost = p->cost;

	if (c + 1 < cost[_reg_NT]) {
		cost[_reg_NT] = c + 1;
		p->rule._reg = 13;
		_closure_reg(a, c + 1);
	}
	if (c < cost[_rc_NT]) {
		cost[_rc_NT] = c;
		p->rule._rc = 2;
		_closure_rc(a, c);
	}
}

static void _stdcall _closure_baseaddr(NODEPTR_TYPE a,int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c;
		p->rule._addr = 2;
		_closure_addr(a, c);
	}
}

static void _stdcall _closure_base(NODEPTR_TYPE a,int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c + 1;
		p->rule._addr = 1;
		_closure_addr(a, c + 1);
	}
}

static void _stdcall _closure_index(NODEPTR_TYPE a,int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c;
		p->rule._addr = 12;
		_closure_addr(a, c);
	}
}

static void _stdcall _closure_addr(NODEPTR_TYPE a,int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 9;
		_closure_reg(a, c + 1);
	}
}

static void _stdcall _closure_memb(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 1;
		p->rule._mrc = 2;
	}
	if (c < p->cost[_mrb_NT]) {
		p->cost[_mrb_NT] = c;
		p->rule._mrb = 2;
		_closure_mrb(a, c);
	}
}

static void _stdcall _closure_memw(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 1;
		p->rule._mrc = 3;
	}
	if (c < p->cost[_mrw_NT]) {
		p->cost[_mrw_NT] = c;
		p->rule._mrw = 2;
		_closure_mrw(a, c);
	}
}

static void _stdcall _closure_mem(NODEPTR_TYPE a, register int c)
{
	struct _state *p = STATE_LABEL(a);
	register short *pcost = p->cost;

	if (c + 2 < pcost[_addrjmp_NT]) {
		pcost[_addrjmp_NT] = c + 2;
		p->rule._addrjmp = 3;
	}
	if (c + 2 < pcost[_addrj_NT]) {
		pcost[_addrj_NT] = c + 2;
		p->rule._addrj = 3;
	}
	if (c < pcost[_mrca_NT]) {
		pcost[_mrca_NT] = c;
		p->rule._mrca = 1;
	}
	if (c + 1 < pcost[_mrc_NT]) {
		pcost[_mrc_NT] = c + 1;
		p->rule._mrc = 1;
	}
	if (c < pcost[_mr_NT]) {
		pcost[_mr_NT] = c;
		p->rule._mr = 2;
		_closure_mr(a, c);
	}
}

static void _stdcall _closure_rc(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c < p->cost[_mrca_NT]) {
		p->cost[_mrca_NT] = c;
		p->rule._mrca = 2;
	}
	if (c < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c;
		p->rule._mrc = 4;
	}
}

static void _stdcall _closure_mr(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 10;
		_closure_reg(a, c + 1);
	}
}

static void _stdcall _closure_mrb(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 11;
		_closure_reg(a, c + 1);
	}
}

static void _stdcall _closure_mrw(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 12;
		_closure_reg(a, c + 1);
	}
}

static void _stdcall _closure_memf(NODEPTR_TYPE a, int c)
{
	struct _state *p = STATE_LABEL(a);
	if (c < p->cost[_flt_NT]) {
		p->cost[_flt_NT] = c;
		p->rule._flt = 1;
	}
	if (c + 3 < p->cost[_freg_NT]) {
		p->cost[_freg_NT] = c + 3;
		p->rule._freg = 3;
		_closure_freg(a, c + 3);
	}
}
#define ck(i) (i) ? 0 : LBURG_MAX
static void _label(NODEPTR_TYPE a)
{
	register int c;
	int rc;
	struct _state *p;
	register short *cost;
	Symbol s;
	short *lc_cost,*rc_cost;
	NODEPTR_TYPE leftChild,rightChild;

	if (!a)
		fatal("_label", "Null tree\n", 0);
	STATE_LABEL(a) = p = allocate(sizeof *p, FUNC);
	p->rule._stmt = 0;
	cost = p->cost;
	cost[1] =
	cost[2] =
	cost[3] =
	cost[4] =
	cost[5] =
	cost[6] =
	cost[7] =
	cost[8] =
	cost[9] =
	cost[10] =
	cost[11] =
	cost[12] =
	cost[13] =
	cost[14] =
	cost[15] =
	cost[16] =
	cost[17] =
	cost[18] =
	cost[19] =
	cost[20] =
	cost[21] =
	cost[22] =
	cost[23] =
	cost[24] =
	cost[25] =
	cost[26] =
		0x7fff;
	leftChild = LEFT_CHILD(a);
	rightChild = RIGHT_CHILD(a);
	switch (OP_LABEL(a)) {
	case 17: /* CNSTF */
		break;
	case 18: /* CNSTD */
		break;
	case 19: /* CNSTC */
		/* con: CNSTC */
		if (0 < cost[_con_NT]) {
			cost[_con_NT] = 0;
			p->rule._con = 1;
			_closure_con(a, 0);
		}
		/* acon: CNSTC */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 2;
		}
		break;
	case 20: /* CNSTS */
		/* con: CNSTS */
		if (0 < cost[_con_NT]) {
			cost[_con_NT] = 0;
			p->rule._con = 4;
			_closure_con(a, 0);
		}
		/* acon: CNSTS */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 5;
		}
		break;
	case 21: /* CNSTI */
		/* con: CNSTI */
		if (0 < cost[_con_NT]) {
			cost[_con_NT] = 0;
			p->rule._con = 2;
			_closure_con(a, 0);
		}
		/* acon: CNSTI */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 3;
		}
		/* con1: CNSTI */
		/* c = range(a, 1, 1); */
		s  = a->syms[0];
		c = ck(s->u.c.v.i  == 1);
		if (c < cost[_con1_NT]) {
			cost[_con1_NT] = c;
			p->rule._con1 = 1;
		}
		/* icon: CNSTI */
		/* c = range(a, 1, 1); */
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 1;
		}
		/* icon: CNSTI */
		/* c = range(a, 2, 2); */
		c = ck(s->u.c.v.i  == 2);
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 3;
		}
		/* icon: CNSTI */
		/* c = range(a, 3, 3); */
		c = ck(s->u.c.v.i  == 3);
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 5;
		}
		/* rc5: CNSTI */
		/* c = range(a, 0, 31); */
		c = ck(s->u.c.v.i  >= 0 && s->u.c.v.i  <= 31);
		if (c < cost[_rc5_NT]) {
			cost[_rc5_NT] = c;
			p->rule._rc5 = 1;
		}
		break;
	case 22: /* CNSTU */
		/* con: CNSTU */
		if (0 < cost[_con_NT]) {
			cost[_con_NT] = 0;
			p->rule._con = 5;
			_closure_con(a, 0);
		}
		/* acon: CNSTU */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 6;
		}
		/* con1: CNSTU */
		/* c = range(a, 1, 1); */
		s  = a->syms[0];
		c = ck(s->u.c.v.u  == 1);
		if (c < cost[_con1_NT]) {
			cost[_con1_NT] = c;
			p->rule._con1 = 2;
		}
		/* icon: CNSTU */
		/* c = range(a, 1, 1); */
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 2;
		}
		/* icon: CNSTU */
		/* c = range(a, 2, 2); */
		c = ck(s->u.c.v.u  == 2);
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 4;
		}
		/* icon: CNSTU */
		/* c = range(a, 3, 3); */
		c = ck(s->u.c.v.u  == 3);
		if (c < cost[_icon_NT]) {
			cost[_icon_NT] = c;
			p->rule._icon = 6;
		}
		break;
	case 23: /* CNSTP */
		/* con: CNSTP */
		if (0 < cost[_con_NT]) {
			cost[_con_NT] = 0;
			p->rule._con = 3;
			_closure_con(a, 0);
		}
		/* acon: CNSTP */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 4;
		}
		break;
	case 33: /* ARGF */
		_label(leftChild);
		/* stmt: ARGF(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 40;
		}
		break;
	case 34: /* ARGD */
		_label(leftChild);
		/* stmt: ARGD(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 39;
		}
		break;
	case 37: /* ARGI */
		_label(leftChild);
		/* stmt: ARGI(mrca) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mrca_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 33;
		}
		break;
	case 39: /* ARGP */
		_label(leftChild);
		/* stmt: ARGP(mrca) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mrca_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 34;
		}
		break;
	case 41: /* ARGB */
		_label(leftChild);
		if (	/* stmt: ARGB(INDIRB(reg)) */
			leftChild->op == 73 /* INDIRB */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 35;
			}
		}
		break;
	case 49: /* ASGNF */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		if (	/* stmt: ASGNF(VREGP,freg) */
			leftChild->op == 615 /* VREGP */
		) {
			c = rc_cost[_freg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 6;
			}
		}
		/* stmt: ASGNF(addr,freg) */
		c = lc_cost[_addr_NT] + rc_cost[_freg_NT] + 7;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 37;
		}
		if (	/* stmt: ASGNF(addr,CVDF(freg)) */
			rightChild->op == 97 /* CVDF */
		) {
			c = lc_cost[_addr_NT] + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_freg_NT] + 7;
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 38;
			}
		}
		break;
	case 50: /* ASGND */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* stmt: ASGND(VREGP,freg) */
		if (leftChild->op == 615) { /* VREGP */
			c = rc_cost[_freg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 5;
			}
		}
		/* stmt: ASGND(addr,freg) */
		c = lc_cost[_addr_NT] + rc_cost[_freg_NT] + 7;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 36;
		}
		break;
	case 51: /* ASGNC */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* stmt: ASGNC(VREGP,reg) */
		if (leftChild->op == 615) { /* VREGP */
			c = rc_cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 1;
			}
		}
		/* stmt: ASGNC(addr,rc) */
		c = lc_cost[_addr_NT] + rc_cost[_rc_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 28;
		}
		break;
	case 52: /* ASGNS */
		_label(leftChild);
		_label(rightChild);
		if (	/* stmt: ASGNS(VREGP,reg) */
			leftChild->op == 615 /* VREGP */
		) {
			c = ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 4;
			}
		}
		/* stmt: ASGNS(addr,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT]
			+ ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 31;
		}
		break;
	case 53: /* ASGNI */
		{
		int cost_addr_NT;
		_label(leftChild);
		_label(rightChild);
		if (	/* stmt: ASGNI(VREGP,reg) */
			leftChild->op == 615 /* VREGP */
		) {
			c = ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 2;
			}
		}
		rc = rightChild->op;
		cost_addr_NT = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		/* stmt: ASGNI(addr,ADDI(mem,con1)) */
		if (rc == 309) { /* ADDI */
			c = cost_addr_NT + 
			((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] +
			 ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 9;
			}
		}
		/* stmt: ASGNI(addr,ADDU(mem,con1)) */
		if (rc == 310) { /* ADDU */
			c = cost_addr_NT + 
			((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 10;
			}
		}
		/* stmt: ASGNI(addr,SUBI(mem,con1)) */
		if (rc == 325 ) { /* SUBI */
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT]
				+ ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT] 
				+ memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 12;
			}
		}
		/* stmt: ASGNI(addr,SUBU(mem,con1)) */
		if (rc == 326 ) { /* SUBU */
			c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT]
				+ ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT]
				+ ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT]
				+ memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 13;
			}
		}
		if (	/* stmt: ASGNI(addr,ADDI(mem,rc)) */
			rc == 309 /* ADDI */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 15;
			}
		}
		/* stmt: ASGNI(addr,ADDU(mem,rc)) */
		/* ADDU */
		if (rc == 310) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 16;
			}
		}
		/* stmt: ASGNI(addr,SUBI(mem,rc)) */
		/* SUBI */
		if (rc == 325) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 17;
			}
		}
		/* stmt: ASGNI(addr,SUBU(mem,rc)) */
		/* SUBU */
		if (rc == 326 ) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 18;
			}
		}
		if (	/* stmt: ASGNI(addr,BANDU(mem,rc)) */
			rc == 390 /* BANDU */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 19;
			}
		}
		/* stmt: ASGNI(addr,BORU(mem,rc)) */
		/* BORU */
		if (rc == 422) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 20;
			}
		}
		if (	/* stmt: ASGNI(addr,BXORU(mem,rc)) */
			rc == 438 /* BXORU */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 21;
			}
		}
		if (	/* stmt: ASGNI(addr,BCOMU(mem)) */
			rc == 406 /* BCOMU */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 22;
			}
		}
		if (	/* stmt: ASGNI(addr,NEGI(mem)) */
			rc == 197 /* NEGI */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 23;
			}
		}
		if (	/* stmt: ASGNI(addr,LSHI(mem,rc5)) */
			rc == 341 /* LSHI */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc5_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 24;
			}
		}
		if (	/* stmt: ASGNI(addr,LSHU(mem,rc5)) */
			rc == 342 /* LSHU */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc5_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 25;
			}
		}
		if (	/* stmt: ASGNI(addr,RSHI(mem,rc5)) */
			rc == 373 /* RSHI */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc5_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 26;
			}
		}
		if (	/* stmt: ASGNI(addr,RSHU(mem,rc5)) */
			rc == 374 /* RSHU */
		) {
			c = cost_addr_NT + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_rc5_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 27;
			}
		}
		/* stmt: ASGNI(addr,rc) */
		c = cost_addr_NT + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 29;
		}
		if (	/* stmt: ASGNI(addr,CVDI(freg)) */
			rightChild->op == 101 /* CVDI */
		) {
			c = cost_addr_NT + 
				((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_freg_NT] + 29;
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 41;
			}
		}
		}
		break;
	case 55: /* ASGNP */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* stmt: ASGNP(VREGP,reg) */
		if (leftChild->op == 615 ) { /* VREGP */
			c =  rc_cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 3;
			}
		}
		/* stmt: ASGNP(addr,ADDP(mem,con1)) */
		if (rightChild->op == 311 ) { /* ADDP */
			c = lc_cost[_addr_NT] + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 11;
			}
		}
		/* stmt: ASGNP(addr,SUBP(mem,con1)) */
		else if (rightChild->op == 327 ) {/* SUBP */
			c = lc_cost[_addr_NT] + ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_mem_NT] + ((struct _state *)(RIGHT_CHILD(rightChild)->x.state))->cost[_con1_NT] + memop(a);
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 14;
			}
		}
		/* stmt: ASGNP(addr,rc) */
		c = lc_cost[_addr_NT] + rc_cost[_rc_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 30;
		}
		break;
	case 57: /* ASGNB */
		_label(leftChild);
		_label(rightChild);
		if (	/* stmt: ASGNB(reg,INDIRB(reg)) */
			rightChild->op == 73 /* INDIRB */
		) {
			c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT]
				+ ((struct _state *)(LEFT_CHILD(rightChild)->x.state))->cost[_reg_NT];
			if (c < cost[_stmt_NT]) {
				cost[_stmt_NT] = c;
				p->rule._stmt = 32;
			}
		}
		break;
	case 65: /* INDIRF */
		_label(leftChild);
		/* freg: INDIRF(VREGP) */
		if (leftChild->op == 615) { /* VREGP */
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if (0 < cost[_freg_NT]) {
				cost[_freg_NT] = 0;
				p->rule._freg = 2;
				_closure_freg(a, 0);
			}
		}
		/* memf: INDIRF(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_memf_NT]) {
			cost[_memf_NT] = c;
			p->rule._memf = 2;
			_closure_memf(a, c);
		}
		/* cmpf: INDIRF(addr) */
		if (c < cost[_cmpf_NT]) {
			cost[_cmpf_NT] = c;
			p->rule._cmpf = 2;
		}
		break;
	case 66: /* INDIRD */
		_label(leftChild);
		if (	/* freg: INDIRD(VREGP) */
			leftChild->op == 615 /* VREGP */
		) {
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if (0 < cost[_freg_NT]) {
				cost[_freg_NT] = 0;
				p->rule._freg = 1;
				_closure_freg(a, 0);
			}
		}
		/* memf: INDIRD(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_memf_NT]) {
			cost[_memf_NT] = c;
			p->rule._memf = 1;
			_closure_memf(a, c);
		}
		/* cmpf: INDIRD(addr) */
		if (c < cost[_cmpf_NT]) {
			cost[_cmpf_NT] = c;
			p->rule._cmpf = 1;
		}
		break;
	case 67: /* INDIRC */
		_label(leftChild);
		if (	/* reg: INDIRC(VREGP) */
			leftChild->op == 615 /* VREGP */
		) {
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if (0 < cost[_reg_NT]) {
				cost[_reg_NT] = 0;
				p->rule._reg = 1;
				_closure_reg(a, 0);
			}
		}
		/* memb: INDIRC(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_memb_NT]) {
			cost[_memb_NT] = c;
			p->rule._memb = 1;
			_closure_memb(a, c);
		}
		break;
	case 68: /* INDIRS */
		_label(leftChild);
		/* reg: INDIRS(VREGP) */
		if (leftChild->op == 615) { /* VREGP */
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if (0 < cost[_reg_NT]) {
				cost[_reg_NT] = 0;
				p->rule._reg = 4;
				_closure_reg(a, 0);
			}
		}
		/* memw: INDIRS(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_memw_NT]) {
			cost[_memw_NT] = c;
			p->rule._memw = 1;
			_closure_memw(a, c);
		}
		break;
	case 69: /* INDIRI */
		_label(leftChild);
		/* reg: INDIRI(VREGP) */
		if (leftChild->op == 615) { /* VREGP */
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if (0 < cost[_reg_NT]) {
				cost[_reg_NT] = 0;
				p->rule._reg = 2;
				_closure_reg(a, 0);
			}
		}
		/* mem: INDIRI(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_mem_NT]) {
			cost[_mem_NT] = c;
			p->rule._mem = 1;
			_closure_mem(a, c);
		}
		break;
	case 71: /* INDIRP */
		_label(leftChild);
		/* reg: INDIRP(VREGP) */
		if (leftChild->op == 615) { /* VREGP */
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				short *qcost = q->cost;
				if (qcost[_stmt_NT] == 0) {
					cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if (qcost[_reg_NT] == 0) {
					cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if (qcost[_freg_NT] == 0) {
					cost[_freg_NT] = 0;
					p->rule._freg = q->rule._freg;
				}
				if (qcost[_con_NT] == 0) {
					cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if (qcost[_acon_NT] == 0) {
					cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if (qcost[_baseaddr_NT] == 0) {
					cost[_baseaddr_NT] = 0;
					p->rule._baseaddr = q->rule._baseaddr;
				}
				if (qcost[_base_NT] == 0) {
					cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if (qcost[_con1_NT] == 0) {
					cost[_con1_NT] = 0;
					p->rule._con1 = q->rule._con1;
				}
				if (qcost[_icon_NT] == 0) {
					cost[_icon_NT] = 0;
					p->rule._icon = q->rule._icon;
				}
				if (qcost[_index_NT] == 0) {
					cost[_index_NT] = 0;
					p->rule._index = q->rule._index;
				}
				if (qcost[_addr_NT] == 0) {
					cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if (qcost[_memb_NT] == 0) {
					cost[_memb_NT] = 0;
					p->rule._memb = q->rule._memb;
				}
				if (qcost[_memw_NT] == 0) {
					cost[_memw_NT] = 0;
					p->rule._memw = q->rule._memw;
				}
				if (qcost[_mem_NT] == 0) {
					cost[_mem_NT] = 0;
					p->rule._mem = q->rule._mem;
				}
				if (qcost[_rc5_NT] == 0) {
					cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if (qcost[_rc_NT] == 0) {
					cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if (qcost[_mr_NT] == 0) {
					cost[_mr_NT] = 0;
					p->rule._mr = q->rule._mr;
				}
				if (qcost[_mrb_NT] == 0) {
					cost[_mrb_NT] = 0;
					p->rule._mrb = q->rule._mrb;
				}
				if (qcost[_mrw_NT] == 0) {
					cost[_mrw_NT] = 0;
					p->rule._mrw = q->rule._mrw;
				}
				if (qcost[_mrc_NT] == 0) {
					cost[_mrc_NT] = 0;
					p->rule._mrc = q->rule._mrc;
				}
				if (qcost[_mrca_NT] == 0) {
					cost[_mrca_NT] = 0;
					p->rule._mrca = q->rule._mrca;
				}
				if (qcost[_memf_NT] == 0) {
					cost[_memf_NT] = 0;
					p->rule._memf = q->rule._memf;
				}
				if (qcost[_flt_NT] == 0) {
					cost[_flt_NT] = 0;
					p->rule._flt = q->rule._flt;
				}
				if (qcost[_addrj_NT] == 0) {
					cost[_addrj_NT] = 0;
					p->rule._addrj = q->rule._addrj;
				}
				if (qcost[_addrjmp_NT] == 0) {
					cost[_addrjmp_NT] = 0;
					p->rule._addrjmp = q->rule._addrjmp;
				}
				if (qcost[_cmpf_NT] == 0) {
					cost[_cmpf_NT] = 0;
					p->rule._cmpf = q->rule._cmpf;
				}
			}
			if ( 0 < cost[_reg_NT]) {
				cost[_reg_NT] = 0;
				p->rule._reg = 3;
				_closure_reg(a, 0);
			}
		}
		/* mem: INDIRP(addr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addr_NT];
		if (c < cost[_mem_NT]) {
			cost[_mem_NT] = c;
			p->rule._mem = 2;
			_closure_mem(a, c);
		}
		break;
	case 73: /* INDIRB */
		_label(leftChild);
		break;
	case 85: /* CVCI */
		_label(leftChild);
		/* reg: CVCI(INDIRC(addr)) */
		if (leftChild->op == 67 ) {/* INDIRC */
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT] + 3;
			if (c < cost[_reg_NT]) {
				cost[_reg_NT] = c;
				p->rule._reg = 45;
				_closure_reg(a, c);
			}
		}
		/* reg: CVCI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 3;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 49;
			_closure_reg(a, c);
		}
		break;
	case 86: /* CVCU */
		leftChild = LEFT_CHILD(a);
		_label(leftChild);
		if (	/* reg: CVCU(INDIRC(addr)) */
			leftChild->op == 67 /* INDIRC */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT] + 3;
			if (c < cost[_reg_NT]) {
				cost[_reg_NT] = c;
				p->rule._reg = 46;
				_closure_reg(a, c);
			}
		}
		/* reg: CVCU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 3;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 50;
			_closure_reg(a, c);
		}
		break;
	case 97: /* CVDF */
		leftChild = LEFT_CHILD(a);
		_label(leftChild);
		/* freg: CVDF(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + 12;
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 19;
			_closure_freg(a, c);
		}
		break;
	case 101: /* CVDI */
		_label(leftChild);
		/* reg: CVDI(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + 31;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 57;
			_closure_reg(a, c);
		}
		break;
	case 114: /* CVFD */
		_label(leftChild);
		if (	/* memf: CVFD(INDIRF(addr)) */
			leftChild->op == 65 /* INDIRF */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT];
			if (c < cost[_memf_NT]) {
				cost[_memf_NT] = c;
				p->rule._memf = 3;
				_closure_memf(a, c);
			}
		}
		/* freg: CVFD(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 18;
			_closure_freg(a, c);
		}
		if (	/* cmpf: CVFD(INDIRF(addr)) */
			leftChild->op == 65 /* INDIRF */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT];
			if (c < cost[_cmpf_NT]) {
				cost[_cmpf_NT] = c;
				p->rule._cmpf = 3;
			}
		}
		break;
	case 130: /* CVID */
		_label(leftChild);
		if (	/* freg: CVID(INDIRI(addr)) */
			leftChild->op == 69 /* INDIRI */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT] + 10;
			if (c < cost[_freg_NT]) {
				cost[_freg_NT] = c;
				p->rule._freg = 20;
				_closure_freg(a, c);
			}
		}
		/* freg: CVID(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 12;
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 21;
			_closure_freg(a, c);
		}
		break;
	case 131: /* CVIC */
		_label(leftChild);
		/* reg: CVIC(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 53;
			_closure_reg(a, c);
		}
		break;
	case 132: /* CVIS */
		_label(leftChild);
		/* reg: CVIS(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 54;
			_closure_reg(a, c);
		}
		break;
	case 134: /* CVIU */
		_label(leftChild);
		/* reg: CVIU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + notarget(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 5;
			_closure_reg(a, c);
		}
		/* reg: CVIU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 41;
			_closure_reg(a, c);
		}
		break;
	case 150: /* CVPU */
		_label(leftChild);
		/* reg: CVPU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + notarget(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 6;
			_closure_reg(a, c);
		}
		/* reg: CVPU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 42;
			_closure_reg(a, c);
		}
		break;
	case 165: /* CVSI */
		_label(leftChild);
		if (	/* reg: CVSI(INDIRS(addr)) */
			leftChild->op == 68 /* INDIRS */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT] + 3;
			if (c < cost[_reg_NT]) {
				cost[_reg_NT] = c;
				p->rule._reg = 47;
				_closure_reg(a, c);
			}
		}
		/* reg: CVSI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 3;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 51;
			_closure_reg(a, c);
		}
		break;
	case 166: /* CVSU */
		_label(leftChild);
		if (	/* reg: CVSU(INDIRS(addr)) */
			leftChild->op == 68 /* INDIRS */
		) {
			c = ((struct _state *)(LEFT_CHILD(leftChild)->x.state))->cost[_addr_NT] + 3;
			if (c < cost[_reg_NT]) {
				cost[_reg_NT] = c;
				p->rule._reg = 48;
				_closure_reg(a, c);
			}
		}
		/* reg: CVSU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 3;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 52;
			_closure_reg(a, c);
		}
		break;
	case 179: /* CVUC */
		_label(leftChild);
		/* reg: CVUC(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 55;
			_closure_reg(a, c);
		}
		break;
	case 180: /* CVUS */
		_label(leftChild);
		/* reg: CVUS(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 56;
			_closure_reg(a, c);
		}
		break;
	case 181: /* CVUI */
		_label(leftChild);
		/* reg: CVUI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + notarget(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 7;
			_closure_reg(a, c);
		}
		/* reg: CVUI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 43;
			_closure_reg(a, c);
		}
		break;
	case 183: /* CVUP */
		_label(leftChild);
		/* reg: CVUP(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + notarget(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 8;
			_closure_reg(a, c);
		}
		/* reg: CVUP(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 44;
			_closure_reg(a, c);
		}
		break;
	case 193: /* NEGF */
		_label(leftChild);
		/* freg: NEGF(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 5;
			_closure_freg(a, c);
		}
		break;
	case 194: /* NEGD */
		_label(leftChild);
		/* freg: NEGD(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 4;
			_closure_freg(a, c);
		}
		break;
	case 197: /* NEGI */
		_label(leftChild);
		/* reg: NEGI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 33;
			_closure_reg(a, c);
		}
		break;
	case 209: /* CALLF */
		_label(leftChild);
		/* freg: CALLF(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + hasargs(a);
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 22;
			_closure_freg(a, c);
		}
		/* freg: CALLF(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + 1;
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 23;
			_closure_freg(a, c);
		}
		/* stmt: CALLF(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + hasargs(a);
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 78;
		}
		/* stmt: CALLF(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 79;
		}
		break;
	case 210: /* CALLD */
		_label(leftChild);
		/* freg: CALLD(addrj) */
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		c = lc_cost[_addrj_NT] + hasargs(a);
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 24;
			_closure_freg(a, c);
		}
		/* freg: CALLD(addrj) */
		c = lc_cost[_addrj_NT] + 1;
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 25;
			_closure_freg(a, c);
		}
		/* stmt: CALLD(addrj) */
		c = lc_cost[_addrj_NT] + hasargs(a);
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 80;
		}
		/* stmt: CALLD(addrj) */
		c = lc_cost[_addrj_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 81;
		}
		break;
	case 213: /* CALLI */
		_label(leftChild);
		/* reg: CALLI(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + hasargs(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 58;
			_closure_reg(a, c);
		}
		/* reg: CALLI(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 59;
			_closure_reg(a, c);
		}
		break;
	case 216: /* CALLV */
		_label(leftChild);
		/* stmt: CALLV(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + hasargs(a);
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 76;
		}
		/* stmt: CALLV(addrj) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrj_NT] + 1;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 77;
		}
		break;
	case 217: /* CALLB */
		break;
	case 225: /* LOADF */
		break;
	case 226: /* LOADD */
		break;
	case 227: /* LOADC */
		_label(leftChild);
		/* reg: LOADC(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 14;
			_closure_reg(a, c);
		}
		break;
	case 228: /* LOADS */
		_label(leftChild);
		/* reg: LOADS(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 17;
			_closure_reg(a, c);
		}
		break;
	case 229: /* LOADI */
		_label(leftChild);
		/* reg: LOADI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 15;
			_closure_reg(a, c);
		}
		break;
	case 230: /* LOADU */
		_label(leftChild);
		/* reg: LOADU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 18;
			_closure_reg(a, c);
		}
		break;
	case 231: /* LOADP */
		_label(leftChild);
		/* reg: LOADP(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + move(a);
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 16;
			_closure_reg(a, c);
		}
		break;
	case 233: /* LOADB */
		break;
	case 241: /* RETF */
		_label(leftChild);
		/* stmt: RETF(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 83;
		}
		break;
	case 242: /* RETD */
		_label(leftChild);
		/* stmt: RETD(freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 84;
		}
		break;
	case 245: /* RETI */
		_label(leftChild);
		/* stmt: RETI(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 82;
		}
		break;
	case 263: /* ADDRGP */
		/* acon: ADDRGP */
		if (0 < cost[_acon_NT]) {
			cost[_acon_NT] = 0;
			p->rule._acon = 1;
		}
		/* baseaddr: ADDRGP */
		if (0 < cost[_baseaddr_NT]) {
			cost[_baseaddr_NT] = 0;
			p->rule._baseaddr = 1;
			_closure_baseaddr(a, 0);
		}
		/* mrca: ADDRGP */
		if (0 < cost[_mrca_NT]) {
			cost[_mrca_NT] = 0;
			p->rule._mrca = 3;
		}
		/* addrj: ADDRGP */
		if (0 < cost[_addrj_NT]) {
			cost[_addrj_NT] = 0;
			p->rule._addrj = 1;
		}
		/* addrjmp: ADDRGP */
		if (0 < cost[_addrjmp_NT]) {
			cost[_addrjmp_NT] = 0;
			p->rule._addrjmp = 1;
		}
		break;
	case 279: /* ADDRFP */
		/* base: ADDRFP */
		if (0 < cost[_base_NT]) {
			cost[_base_NT] = 0;
			p->rule._base = 5;
			_closure_base(a, 0);
		}
		break;
	case 295: /* ADDRLP */
		/* base: ADDRLP */
		if (0 < cost[_base_NT]) {
			cost[_base_NT] = 0;
			p->rule._base = 6;
			_closure_base(a, 0);
		}
		break;
	case 305: /* ADDF */
		_label(leftChild);
		_label(rightChild);
		/* freg: ADDF(freg,flt) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_flt_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 7;
			_closure_freg(a, c);
		}
		break;
	case 306: /* ADDD */
		_label(leftChild);
		_label(rightChild);
		/* freg: ADDD(freg,flt) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_flt_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 6;
			_closure_freg(a, c);
		}
		break;
	case 309: /* ADDI */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* base: ADDI(reg,acon) */
		c = lc_cost[_reg_NT] + rc_cost[_acon_NT];
		if (c < cost[_base_NT]) {
			cost[_base_NT] = c;
			p->rule._base = 2;
			_closure_base(a, c);
		}
		/* addr: ADDI(index,baseaddr) */
		c = lc_cost[_index_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 3;
			_closure_addr(a, c);
		}
		/* addr: ADDI(reg,baseaddr) */
		c = lc_cost[_reg_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 4;
			_closure_addr(a, c);
		}
		/* addr: ADDI(index,reg) */
		c = lc_cost[_index_NT] + rc_cost[_reg_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 5;
			_closure_addr(a, c);
		}
		/* reg: ADDI(reg,mrc) */
		c = lc_cost[_reg_NT] + rc_cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 19;
			_closure_reg(a, c);
		}
		break;
	case 310: /* ADDU */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* base: ADDU(reg,acon) */
		c = lc_cost[_reg_NT] + rc_cost[_acon_NT];
		if (c < cost[_base_NT]) {
			cost[_base_NT] = c;
			p->rule._base = 4;
			_closure_base(a, c);
		}
		/* addr: ADDU(index,baseaddr) */
		c = lc_cost[_index_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 9;
			_closure_addr(a, c);
		}
		/* addr: ADDU(reg,baseaddr) */
		c = lc_cost[_reg_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 10;
			_closure_addr(a, c);
		}
		/* addr: ADDU(index,reg) */
		c = lc_cost[_index_NT] + rc_cost[_reg_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 11;
			_closure_addr(a, c);
		}
		/* reg: ADDU(reg,mrc) */
		c = lc_cost[_reg_NT] + rc_cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 21;
			_closure_reg(a, c);
		}
		break;
	case 311: /* ADDP */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* base: ADDP(reg,acon) */
		c = lc_cost[_reg_NT] + rc_cost[_acon_NT];
		if (c < cost[_base_NT]) {
			cost[_base_NT] = c;
			p->rule._base = 3;
			_closure_base(a, c);
		}
		/* addr: ADDP(index,baseaddr) */
		c = lc_cost[_index_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 6;
			_closure_addr(a, c);
		}
		/* addr: ADDP(reg,baseaddr) */
		c = lc_cost[_reg_NT] + rc_cost[_baseaddr_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 7;
			_closure_addr(a, c);
		}
		/* addr: ADDP(index,reg) */
		c = lc_cost[_index_NT] + rc_cost[_reg_NT];
		if (c < cost[_addr_NT]) {
			cost[_addr_NT] = c;
			p->rule._addr = 8;
			_closure_addr(a, c);
		}
		/* reg: ADDP(reg,mrc) */
		c = lc_cost[_reg_NT] + rc_cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 20;
			_closure_reg(a, c);
		}
		break;
	case 321: /* SUBF */
		_label(leftChild);
		_label(rightChild);
		/* freg: SUBF(freg,memf) */
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		c = lc_cost[_freg_NT] + rc_cost[_memf_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 16;
			_closure_freg(a, c);
		}
		/* freg: SUBF(freg,freg) */
		c = lc_cost[_freg_NT] + rc_cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 17;
			_closure_freg(a, c);
		}
		break;
	case 322: /* SUBD */
		_label(leftChild);
		_label(rightChild);
		lc_cost = ((struct _state *)(leftChild->x.state))->cost;
		rc_cost = ((struct _state *)(rightChild->x.state))->cost;
		/* freg: SUBD(freg,memf) */
		c = lc_cost[_freg_NT] + rc_cost[_memf_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 14;
			_closure_freg(a, c);
		}
		/* freg: SUBD(freg,freg) */
		c = lc_cost[_freg_NT] + rc_cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 15;
			_closure_freg(a, c);
		}
		break;
	case 325: /* SUBI */
		_label(leftChild);
		_label(rightChild);
		/* reg: SUBI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 22;
			_closure_reg(a, c);
		}
		break;
	case 326: /* SUBU */
		_label(leftChild);
		_label(rightChild);
		/* reg: SUBU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 24;
			_closure_reg(a, c);
		}
		break;
	case 327: /* SUBP */
		_label(leftChild);
		_label(rightChild);
		/* reg: SUBP(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 23;
			_closure_reg(a, c);
		}
		break;
	case 341: /* LSHI */
		_label(leftChild);
		_label(rightChild);
		/* index: LSHI(reg,icon) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_icon_NT];
		if (c < cost[_index_NT]) {
			cost[_index_NT] = c;
			p->rule._index = 2;
			_closure_index(a, c);
		}
		/* reg: LSHI(reg,rc5) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc5_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 28;
			_closure_reg(a, c);
		}
		break;
	case 342: /* LSHU */
		_label(leftChild);
		_label(rightChild);
		/* index: LSHU(reg,icon) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_icon_NT];
		if (c < cost[_index_NT]) {
			cost[_index_NT] = c;
			p->rule._index = 3;
			_closure_index(a, c);
		}
		/* reg: LSHU(reg,rc5) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc5_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 29;
			_closure_reg(a, c);
		}
		break;
	case 357: /* MODI */
		_label(leftChild);
		_label(rightChild);
		/* reg: MODI(reg,reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 40;
			_closure_reg(a, c);
		}
		break;
	case 358: /* MODU */
		_label(leftChild);
		_label(rightChild);
		/* reg: MODU(reg,reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 38;
			_closure_reg(a, c);
		}
		break;
	case 373: /* RSHI */
		_label(leftChild);
		_label(rightChild);
		/* reg: RSHI(reg,rc5) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc5_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 30;
			_closure_reg(a, c);
		}
		break;
	case 374: /* RSHU */
		_label(leftChild);
		_label(rightChild);
		/* reg: RSHU(reg,rc5) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc5_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 31;
			_closure_reg(a, c);
		}
		break;
	case 390: /* BANDU */
		_label(leftChild);
		_label(rightChild);
		/* reg: BANDU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 25;
			_closure_reg(a, c);
		}
		break;
	case 406: /* BCOMU */
		_label(leftChild);
		/* reg: BCOMU(reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + 2;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 32;
			_closure_reg(a, c);
		}
		break;
	case 422: /* BORU */
		_label(leftChild);
		_label(rightChild);
		/* reg: BORU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 26;
			_closure_reg(a, c);
		}
		break;
	case 438: /* BXORU */
		_label(leftChild);
		_label(rightChild);
		/* reg: BXORU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 1;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 27;
			_closure_reg(a, c);
		}
		break;
	case 449: /* DIVF */
		_label(leftChild);
		_label(rightChild);
		/* freg: DIVF(freg,memf) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_memf_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 10;
			_closure_freg(a, c);
		}
		/* freg: DIVF(freg,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 11;
			_closure_freg(a, c);
		}
		break;
	case 450: /* DIVD */
		_label(leftChild);
		_label(rightChild);
		/* freg: DIVD(freg,memf) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_memf_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 8;
			_closure_freg(a, c);
		}
		/* freg: DIVD(freg,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 9;
			_closure_freg(a, c);
		}
		break;
	case 453: /* DIVI */
		_label(leftChild);
		_label(rightChild);
		/* reg: DIVI(reg,reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 39;
			_closure_reg(a, c);
		}
		break;
	case 454: /* DIVU */
		_label(leftChild);
		_label(rightChild);
		/* reg: DIVU(reg,reg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_reg_NT];
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 37;
			_closure_reg(a, c);
		}
		break;
	case 465: /* MULF */
		_label(leftChild);
		_label(rightChild);
		/* freg: MULF(freg,flt) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_flt_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 13;
			_closure_freg(a, c);
		}
		break;
	case 466: /* MULD */
		_label(leftChild);
		_label(rightChild);
		/* freg: MULD(freg,flt) */
		c = ((struct _state *)(leftChild->x.state))->cost[_freg_NT] + ((struct _state *)(rightChild->x.state))->cost[_flt_NT];
		if (c < cost[_freg_NT]) {
			cost[_freg_NT] = c;
			p->rule._freg = 12;
			_closure_freg(a, c);
		}
		break;
	case 469: /* MULI */
		_label(leftChild);
		_label(rightChild);
		/* reg: MULI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT]
			+ ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 14;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 34;
			_closure_reg(a, c);
		}
		/* reg: MULI(con,mr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_con_NT] + ((struct _state *)(rightChild->x.state))->cost[_mr_NT] + 13;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 35;
			_closure_reg(a, c);
		}
		break;
	case 470: /* MULU */
		_label(leftChild);
		_label(rightChild);
		/* reg: MULU(reg,mr) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mr_NT] + 13;
		if (c < cost[_reg_NT]) {
			cost[_reg_NT] = c;
			p->rule._reg = 36;
			_closure_reg(a, c);
		}
		break;
	case 481: /* EQF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: EQF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT]
			+ ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 70;
		}
		break;
	case 482: /* EQD */
		_label(leftChild);
		_label(rightChild);
		/* stmt: EQD(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 64;
		}
		break;
	case 485: /* EQI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: EQI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 44;
		}
		/* stmt: EQI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 54;
		}
		break;
	case 497: /* GEF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GEF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 71;
		}
		break;
	case 498: /* GED */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GED(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 65;
		}
		break;
	case 501: /* GEI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GEI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 45;
		}
		/* stmt: GEI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 55;
		}
		break;
	case 502: /* GEU */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GEU(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 50;
		}
		/* stmt: GEU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 60;
		}
		break;
	case 513: /* GTF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GTF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 72;
		}
		break;
	case 514: /* GTD */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GTD(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 66;
		}
		break;
	case 517: /* GTI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GTI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 46;
		}
		/* stmt: GTI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 56;
		}
		break;
	case 518: /* GTU */
		_label(leftChild);
		_label(rightChild);
		/* stmt: GTU(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 51;
		}
		/* stmt: GTU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 61;
		}
		break;
	case 529: /* LEF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LEF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 73;
		}
		break;
	case 530: /* LED */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LED(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 67;
		}
		break;
	case 533: /* LEI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LEI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 47;
		}
		/* stmt: LEI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 57;
		}
		break;
	case 534: /* LEU */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LEU(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 52;
		}
		/* stmt: LEU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 62;
		}
		break;
	case 545: /* LTF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LTF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 74;
		}
		break;
	case 546: /* LTD */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LTD(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 68;
		}
		break;
	case 549: /* LTI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LTI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 48;
		}
		/* stmt: LTI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 58;
		}
		break;
	case 550: /* LTU */
		_label(leftChild);
		_label(rightChild);
		/* stmt: LTU(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 53;
		}
		/* stmt: LTU(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 63;
		}
		break;
	case 561: /* NEF */
		_label(leftChild);
		_label(rightChild);
		/* stmt: NEF(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 75;
		}
		break;
	case 562: /* NED */
		_label(leftChild);
		_label(rightChild);
		/* stmt: NED(cmpf,freg) */
		c = ((struct _state *)(leftChild->x.state))->cost[_cmpf_NT] + ((struct _state *)(rightChild->x.state))->cost[_freg_NT];
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 69;
		}
		break;
	case 565: /* NEI */
		_label(leftChild);
		_label(rightChild);
		/* stmt: NEI(mem,rc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_mem_NT] + ((struct _state *)(rightChild->x.state))->cost[_rc_NT] + 5;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 49;
		}
		/* stmt: NEI(reg,mrc) */
		c = ((struct _state *)(leftChild->x.state))->cost[_reg_NT] + ((struct _state *)(rightChild->x.state))->cost[_mrc_NT] + 4;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 59;
		}
		break;
	case 584: /* JUMPV */
		_label(leftChild);
		/* stmt: JUMPV(addrjmp) */
		c = ((struct _state *)(leftChild->x.state))->cost[_addrjmp_NT] + 3;
		if (c < cost[_stmt_NT]) {
			cost[_stmt_NT] = c;
			p->rule._stmt = 43;
		}
		break;
	case 600: /* LABELV */
		/* stmt: LABELV */
		if (0 < cost[_stmt_NT]) {
			cost[_stmt_NT] = 0;
			p->rule._stmt = 42;
		}
		break;
	case 615: /* VREGP */
		break;
	default:
		fatal("_label", "Bad terminal %d\n", OP_LABEL(a));
	}
}

static void _kids(NODEPTR_TYPE p,int eruleno,NODEPTR_TYPE kids[])
{
	if (!p)
		fatal("_kids", "Null tree\n", 0);
	if (!kids)
		fatal("_kids", "Null kids\n", 0);
	switch (eruleno) {
	case 193: /* stmt: LABELV */
	case 190: /* addrjmp: ADDRGP */
	case 187: /* addrj: ADDRGP */
	case 147: /* mrca: ADDRGP */
	case 64: /* rc5: CNSTI */
	case 44: /* icon: CNSTU */
	case 43: /* icon: CNSTI */
	case 42: /* icon: CNSTU */
	case 41: /* icon: CNSTI */
	case 40: /* icon: CNSTU */
	case 39: /* icon: CNSTI */
	case 38: /* con1: CNSTU */
	case 37: /* con1: CNSTI */
	case 36: /* base: ADDRLP */
	case 35: /* base: ADDRFP */
	case 30: /* baseaddr: ADDRGP */
	case 29: /* acon: CNSTU */
	case 28: /* acon: CNSTS */
	case 27: /* acon: CNSTP */
	case 26: /* acon: CNSTI */
	case 25: /* acon: CNSTC */
	case 24: /* acon: ADDRGP */
	case 17: /* con: CNSTU */
	case 16: /* con: CNSTS */
	case 15: /* con: CNSTP */
	case 14: /* con: CNSTI */
	case 13: /* con: CNSTC */
	case 6: /* freg: INDIRF(VREGP) */
	case 5: /* freg: INDIRD(VREGP) */
	case 4: /* reg: INDIRS(VREGP) */
	case 3: /* reg: INDIRP(VREGP) */
	case 2: /* reg: INDIRI(VREGP) */
	case 1: /* reg: INDIRC(VREGP) */
		break;
	case 12: /* stmt: ASGNF(VREGP,freg) */
	case 11: /* stmt: ASGND(VREGP,freg) */
	case 10: /* stmt: ASGNS(VREGP,reg) */
	case 9: /* stmt: ASGNP(VREGP,reg) */
	case 8: /* stmt: ASGNI(VREGP,reg) */
	case 7: /* stmt: ASGNC(VREGP,reg) */
		kids[0] = RIGHT_CHILD(p);
		break;
	case 218: /* cmpf: freg */
	case 192: /* addrjmp: mem */
	case 191: /* addrjmp: reg */
	case 189: /* addrj: mem */
	case 188: /* addrj: reg */
	case 168: /* flt: freg */
	case 167: /* flt: memf */
	case 159: /* freg: memf */
	case 146: /* mrca: rc */
	case 145: /* mrca: mem */
	case 82: /* reg: con */
	case 81: /* reg: mrw */
	case 80: /* reg: mrb */
	case 79: /* reg: mr */
	case 78: /* reg: addr */
	case 77: /* mrc: rc */
	case 76: /* mrc: memw */
	case 75: /* mrc: memb */
	case 74: /* mrc: mem */
	case 73: /* mrw: memw */
	case 72: /* mrw: reg */
	case 71: /* mrb: memb */
	case 70: /* mrb: reg */
	case 69: /* mr: mem */
	case 68: /* mr: reg */
	case 67: /* rc: con */
	case 66: /* rc: reg */
	case 65: /* rc5: reg */
	case 59: /* addr: index */
	case 49: /* addr: baseaddr */
	case 48: /* addr: base */
	case 45: /* index: reg */
	case 31: /* base: reg */
	case 19: /* stmt: freg */
	case 18: /* stmt: reg */
		kids[0] = p;
		break;
	case 245: /* stmt: RETD(freg) */
	case 244: /* stmt: RETF(freg) */
	case 243: /* stmt: RETI(reg) */
	case 242: /* stmt: CALLD(addrj) */
	case 241: /* stmt: CALLD(addrj) */
	case 240: /* freg: CALLD(addrj) */
	case 239: /* freg: CALLD(addrj) */
	case 238: /* stmt: CALLF(addrj) */
	case 237: /* stmt: CALLF(addrj) */
	case 236: /* freg: CALLF(addrj) */
	case 235: /* freg: CALLF(addrj) */
	case 234: /* stmt: CALLV(addrj) */
	case 233: /* stmt: CALLV(addrj) */
	case 232: /* reg: CALLI(addrj) */
	case 231: /* reg: CALLI(addrj) */
	case 216: /* cmpf: INDIRF(addr) */
	case 215: /* cmpf: INDIRD(addr) */
	case 194: /* stmt: JUMPV(addrjmp) */
	case 186: /* freg: CVID(reg) */
	case 184: /* reg: CVDI(freg) */
	case 182: /* freg: CVDF(freg) */
	case 181: /* freg: CVFD(freg) */
	case 166: /* freg: NEGF(freg) */
	case 165: /* freg: NEGD(freg) */
	case 164: /* stmt: ARGF(freg) */
	case 163: /* stmt: ARGD(freg) */
	case 157: /* memf: INDIRF(addr) */
	case 156: /* memf: INDIRD(addr) */
	case 154: /* stmt: ARGP(mrca) */
	case 153: /* stmt: ARGI(mrca) */
	case 144: /* reg: CVUS(reg) */
	case 143: /* reg: CVUC(reg) */
	case 142: /* reg: CVIS(reg) */
	case 141: /* reg: CVIC(reg) */
	case 140: /* reg: CVSU(reg) */
	case 139: /* reg: CVSI(reg) */
	case 138: /* reg: CVCU(reg) */
	case 137: /* reg: CVCI(reg) */
	case 132: /* reg: CVUP(reg) */
	case 131: /* reg: CVUI(reg) */
	case 130: /* reg: CVPU(reg) */
	case 129: /* reg: CVIU(reg) */
	case 102: /* reg: NEGI(reg) */
	case 101: /* reg: BCOMU(reg) */
	case 87: /* reg: LOADU(reg) */
	case 86: /* reg: LOADS(reg) */
	case 85: /* reg: LOADP(reg) */
	case 84: /* reg: LOADI(reg) */
	case 83: /* reg: LOADC(reg) */
	case 63: /* mem: INDIRP(addr) */
	case 62: /* mem: INDIRI(addr) */
	case 61: /* memw: INDIRS(addr) */
	case 60: /* memb: INDIRC(addr) */
	case 23: /* reg: CVUP(reg) */
	case 22: /* reg: CVUI(reg) */
	case 21: /* reg: CVPU(reg) */
	case 20: /* reg: CVIU(reg) */
		kids[0] = LEFT_CHILD(p);
		break;
	case 230: /* stmt: NEF(cmpf,freg) */
	case 229: /* stmt: LTF(cmpf,freg) */
	case 228: /* stmt: LEF(cmpf,freg) */
	case 227: /* stmt: GTF(cmpf,freg) */
	case 226: /* stmt: GEF(cmpf,freg) */
	case 225: /* stmt: EQF(cmpf,freg) */
	case 224: /* stmt: NED(cmpf,freg) */
	case 223: /* stmt: LTD(cmpf,freg) */
	case 222: /* stmt: LED(cmpf,freg) */
	case 221: /* stmt: GTD(cmpf,freg) */
	case 220: /* stmt: GED(cmpf,freg) */
	case 219: /* stmt: EQD(cmpf,freg) */
	case 214: /* stmt: LTU(reg,mrc) */
	case 213: /* stmt: LEU(reg,mrc) */
	case 212: /* stmt: GTU(reg,mrc) */
	case 211: /* stmt: GEU(reg,mrc) */
	case 210: /* stmt: NEI(reg,mrc) */
	case 209: /* stmt: LTI(reg,mrc) */
	case 208: /* stmt: LEI(reg,mrc) */
	case 207: /* stmt: GTI(reg,mrc) */
	case 206: /* stmt: GEI(reg,mrc) */
	case 205: /* stmt: EQI(reg,mrc) */
	case 204: /* stmt: LTU(mem,rc) */
	case 203: /* stmt: LEU(mem,rc) */
	case 202: /* stmt: GTU(mem,rc) */
	case 201: /* stmt: GEU(mem,rc) */
	case 200: /* stmt: NEI(mem,rc) */
	case 199: /* stmt: LTI(mem,rc) */
	case 198: /* stmt: LEI(mem,rc) */
	case 197: /* stmt: GTI(mem,rc) */
	case 196: /* stmt: GEI(mem,rc) */
	case 195: /* stmt: EQI(mem,rc) */
	case 180: /* freg: SUBF(freg,freg) */
	case 179: /* freg: SUBF(freg,memf) */
	case 178: /* freg: SUBD(freg,freg) */
	case 177: /* freg: SUBD(freg,memf) */
	case 176: /* freg: MULF(freg,flt) */
	case 175: /* freg: MULD(freg,flt) */
	case 174: /* freg: DIVF(freg,freg) */
	case 173: /* freg: DIVF(freg,memf) */
	case 172: /* freg: DIVD(freg,freg) */
	case 171: /* freg: DIVD(freg,memf) */
	case 170: /* freg: ADDF(freg,flt) */
	case 169: /* freg: ADDD(freg,flt) */
	case 161: /* stmt: ASGNF(addr,freg) */
	case 160: /* stmt: ASGND(addr,freg) */
	case 151: /* stmt: ASGNS(addr,rc) */
	case 150: /* stmt: ASGNP(addr,rc) */
	case 149: /* stmt: ASGNI(addr,rc) */
	case 148: /* stmt: ASGNC(addr,rc) */
	case 128: /* reg: MODI(reg,reg) */
	case 127: /* reg: DIVI(reg,reg) */
	case 126: /* reg: MODU(reg,reg) */
	case 125: /* reg: DIVU(reg,reg) */
	case 124: /* reg: MULU(reg,mr) */
	case 123: /* reg: MULI(con,mr) */
	case 122: /* reg: MULI(reg,mrc) */
	case 100: /* reg: RSHU(reg,rc5) */
	case 99: /* reg: RSHI(reg,rc5) */
	case 98: /* reg: LSHU(reg,rc5) */
	case 97: /* reg: LSHI(reg,rc5) */
	case 96: /* reg: BXORU(reg,mrc) */
	case 95: /* reg: BORU(reg,mrc) */
	case 94: /* reg: BANDU(reg,mrc) */
	case 93: /* reg: SUBU(reg,mrc) */
	case 92: /* reg: SUBP(reg,mrc) */
	case 91: /* reg: SUBI(reg,mrc) */
	case 90: /* reg: ADDU(reg,mrc) */
	case 89: /* reg: ADDP(reg,mrc) */
	case 88: /* reg: ADDI(reg,mrc) */
	case 58: /* addr: ADDU(index,reg) */
	case 57: /* addr: ADDU(reg,baseaddr) */
	case 56: /* addr: ADDU(index,baseaddr) */
	case 55: /* addr: ADDP(index,reg) */
	case 54: /* addr: ADDP(reg,baseaddr) */
	case 53: /* addr: ADDP(index,baseaddr) */
	case 52: /* addr: ADDI(index,reg) */
	case 51: /* addr: ADDI(reg,baseaddr) */
	case 50: /* addr: ADDI(index,baseaddr) */
	case 47: /* index: LSHU(reg,icon) */
	case 46: /* index: LSHI(reg,icon) */
	case 34: /* base: ADDU(reg,acon) */
	case 33: /* base: ADDP(reg,acon) */
	case 32: /* base: ADDI(reg,acon) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = RIGHT_CHILD(p);
		break;
	case 121: /* stmt: ASGNI(addr,RSHU(mem,rc5)) */
	case 120: /* stmt: ASGNI(addr,RSHI(mem,rc5)) */
	case 119: /* stmt: ASGNI(addr,LSHU(mem,rc5)) */
	case 118: /* stmt: ASGNI(addr,LSHI(mem,rc5)) */
	case 115: /* stmt: ASGNI(addr,BXORU(mem,rc)) */
	case 114: /* stmt: ASGNI(addr,BORU(mem,rc)) */
	case 113: /* stmt: ASGNI(addr,BANDU(mem,rc)) */
	case 112: /* stmt: ASGNI(addr,SUBU(mem,rc)) */
	case 111: /* stmt: ASGNI(addr,SUBI(mem,rc)) */
	case 110: /* stmt: ASGNI(addr,ADDU(mem,rc)) */
	case 109: /* stmt: ASGNI(addr,ADDI(mem,rc)) */
	case 108: /* stmt: ASGNP(addr,SUBP(mem,con1)) */
	case 107: /* stmt: ASGNI(addr,SUBU(mem,con1)) */
	case 106: /* stmt: ASGNI(addr,SUBI(mem,con1)) */
	case 105: /* stmt: ASGNP(addr,ADDP(mem,con1)) */
	case 104: /* stmt: ASGNI(addr,ADDU(mem,con1)) */
	case 103: /* stmt: ASGNI(addr,ADDI(mem,con1)) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = LEFT_CHILD(RIGHT_CHILD(p));
		kids[2] = RIGHT_CHILD(RIGHT_CHILD(p));
		break;
	case 183: /* stmt: ASGNI(addr,CVDI(freg)) */
	case 162: /* stmt: ASGNF(addr,CVDF(freg)) */
	case 152: /* stmt: ASGNB(reg,INDIRB(reg)) */
	case 117: /* stmt: ASGNI(addr,NEGI(mem)) */
	case 116: /* stmt: ASGNI(addr,BCOMU(mem)) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = LEFT_CHILD(RIGHT_CHILD(p));
		break;
	case 217: /* cmpf: CVFD(INDIRF(addr)) */
	case 185: /* freg: CVID(INDIRI(addr)) */
	case 158: /* memf: CVFD(INDIRF(addr)) */
	case 155: /* stmt: ARGB(INDIRB(reg)) */
	case 136: /* reg: CVSU(INDIRS(addr)) */
	case 135: /* reg: CVSI(INDIRS(addr)) */
	case 134: /* reg: CVCU(INDIRC(addr)) */
	case 133: /* reg: CVCI(INDIRC(addr)) */
		kids[0] = LEFT_CHILD(LEFT_CHILD(p));
		break;
	default:
		fatal("_kids", "Bad rule number %d\n", eruleno);
	}
}

#ifndef ASM_LIB
static int sametree(Node p,Node q)
{
	return p == NULL && q == NULL
		|| p && q && p->op == q->op && p->syms[0] == q->syms[0]
		&& sametree(p->kids[0], q->kids[0])
		&& sametree(p->kids[1], q->kids[1]);
}
#endif

void SetFastCompile(Interface *i)
{
	i->x._label = _label;
	i->x._rule = _rule;
	i->x._nts = _nts;
	i->x._kids = _kids;
	i->x._string = _opname;
	i->x._arity = _arity;
	i->x._string = _string;
	i->x._templates = _templates;
	i->x._isinstruction = _isinstruction;
	i->x._ntname = _ntname;
}
static int memop(Node p)
{
	assert(p);
	assert(generic(p->op) == ASGN);
	assert(p->kids[0]);
	assert(p->kids[1]);
	if (generic(p->kids[1]->kids[0]->op) == INDIR
	    && sametree(p->kids[0], p->kids[1]->kids[0]->kids[0]))
		return 3;
	else
		return LBURG_MAX;
}
static int hasargs(Node p)
{
	assert(p);
	assert(generic(p->op) == CALL);
	assert(p->syms[0]);
	if (p->x.Flags)
		return LBURG_MAX;
	if (p->syms[0]->u.c.v.i > 0)
		return 0;
	return LBURG_MAX;
}
